##############################################################
#                                                            #
#                       LIQUID WEATHER ++                    #
#                                                            #
#   Copyright:Matthew - dmbkiwi@yahoo.com                    #
#   License:  GPL2                                           #
#   A superkaramba theme                                     #
#                                                            #
##############################################################

#this import statement allows access to the karamba functions
import karamba
import os
import string
import time
import urllib
import urllib2
from os.path import expanduser
import copy
from threading import *

# Configuration
#
# YOU DONT NEED TO EDIT ANYTHING HERE.  DO IT FROM WITHIN THE PROGRAM
#
# I REPEAT -
#
#
# You don't need to edit ANYTHING.  Just run the widget and use the
# "Configure Theme" submenu to change everything


# SETUP URL'S TO DOWNLOAD WEATHER DATA
#
# URL's to download weather data:
url = 'http://xoap.weather.com/weather/local/NZXX0049?cc=*&dayf=5&prod=xoap&par=1003666583&key=4128909340a9b2fc'
url_base_addr = 'http://xoap.weather.com/weather/local/'
url_suffix = '?cc=*&dayf=5&prod=xoap&par=1003666583&key=4128909340a9b2fc'
url_bbc_base_addr = 'http://www.bbc.co.uk/print/weather/5day.shtml?world='
url_bbc_add_addr =  '&print'
#
# URL for webcam:
webcamurls = ['http://homepages.ihug.co.nz/%7Eseebee/webcam/wgtn_harbour.jpg']
#
#
# Where k_weather.py and the cached copy of the html page
# should be kept:
installed = '~/.superkaramba'

# SETUP SOME BASIC VARIABLES WITH DEFAULT VALUES:

metric_units = 0
days = 5
clock = 0
threadflag = 1
dnamobst = 0
#
# If 1, then the high temperature will be displayed first.
# Otherwise, the low temperature will be displayed first
order = 0
#
# This changes the separator between the high and low values:
separator = "/"
#
# This is the initial background if not set in the config file:
mainback = "bg1.png"
#
# If 1, then wind arrows point towards where the wind is blowing to:
windy = 0
webcamlabels = ['Wellington Harbour']
nowebcams = 0
timegate = 0
configchange = 0
webbypic = None
satpic = None
webcams = 0
webcamdisplay = 0
whichone = 0
use_wcom = 1
wcomcode = 'NZXX0049'
satpicon = 0
sumpicon = 0
presspicon = 0
iconset = 'liquid'
iconsetpath = 'icons/liquid/'
flatflag = 0
flatstring = ''
print "flatstring:" + flatstring
werethreading = 0
colour = 'black'
altback = 0
delay = 0
kxdocker = 0
kxdocker_running = 0
kxdocker_lasttime = 0
language = 'English'
red = 0
green = 0
blue = 0
reddrop = 0
greendrop = 0
bluedrop = 0
dropdownflag = 0
delaylist = [3600.0, 7200.0, 10800.0]
prefix = 'http://maps.wunderground.com/data/640x480/'
forecastprefix = 'http://www.accuweather.com/adc_images2/english/forecast/tmpicn/640x480/'
forelocations = ['namer_todtmpicn.gif','camer_todtmpicn.gif','samer_todtmpicn.gif', 'eur_todtmpicn.gif','asia_todtmpicn.gif','afr_todtmpicn.gif','au_todtmpicn.gif','rs_todtmpicn.gif']
shadow = 0
# This is the threading engine.

class Future:

    def __init__(self,func,*param):
        # Constructor
        self.__done=0
        self.__result=None
        self.__status='working'
        self.__excpt=None
        self.__C=Condition()   # Notify on this Condition when result is ready
        # Run the actual function in a separate thread
        self.__T=Thread(target=self.Wrapper,args=(func,param))
        self.__T.setName("FutureThread")
        self.__T.start()

    def __repr__(self):
        return '<Future at '+hex(id(self))+':'+self.__status+'>'

    def isDone(self):
        return self.__done    # Notify if the function is complete

    def __call__(self):
        self.__C.acquire()
        while self.__done==0:
            self.__C.wait()
        self.__C.release()
        # An exception was thrown in the thread, re-raise it here.
        if self.__excpt: raise self.__excpt
        # We deepcopy __result to prevent accidental tampering with it.
        a=copy.deepcopy(self.__result)
        return a

    def Wrapper(self, func, param):
        # Run the actual function, and let us housekeep around it
        self.__C.acquire()
        try:
            self.__result=func(*param)
        except Exception, e: # We got an exception object, save it.
            self.__excpt = e
        except:
            self.__result="Exception raised within Future"
        self.__done=1
        self.__status=`self.__result`
        self.__C.notify()
        self.__C.release()

# This function calls the data gathering functions, each in a separate thread
# which improves speed, and stops the theme freezing while downloading data
def getThreadedData(widget):
    global weatherthread, satpicthread, webcamthread, sumpicthread, load
    weatherthread = Future(getWeather,widget)
    webcamthread = Future(getWebcamPic,widget)
    load = Future(loadingBar,widget)    #Start progress bar in a separate thread

# Function to display progress of downloading data
def loadingBar(widget):
    global werethreading
    loadbarlist = ['nothing' + flatstring + '.png', 'half' + flatstring + '.png', 'done' + flatstring + '.png']
    progress = 0
    previous = 0
    total = 2    # This reflects 3 data threads if using BBC
    if flatflag == 1:
        loadbar = karamba.createImage(widget, 36, 105, loadbarlist[progress])
    else:
        loadbar = karamba.createImage(widget, 120, 94, loadbarlist[progress])
    karamba.redrawWidget(widget)
    while progress < 2:
        progress = weatherthread.isDone() + webcamthread.isDone() # Check how many threads finished
        # Following if statement means that widget only
        # gets redrawn when a thread completes - removes ugly flicker
        if progress != previous:
            karamba.deleteImage(widget, loadbar)
            if flatflag == 1:
                loadbar = karamba.createImage(widget, 36, 105, loadbarlist[progress])
            else:
                loadbar = karamba.createImage(widget, 120, 94, loadbarlist[progress])
            karamba.redrawWidget(widget)
        time.sleep(1)    # Reduce cpu load - not sure if this is necessary
        if progress == total:
            break
        previous = progress
    karamba.deleteImage(widget, loadbar)
    karamba.redrawWidget(widget)
    werethreading = 0
    widgetUpdated(widget)

def getTranslation(widget):

    global transmenu_dict, transcont_dict, transmap_dict, transtool_dict, transsky_dict, transdrop_dict, transweek_dict, transdial_dict
    
    import re
    
    langfile = open(karamba.getThemePath(widget) + 'translations/' + language, 'r')
    transfile = langfile.read()
    
    data_configmenu = transfile[transfile.find('<CONFIGURE_MENU>'):transfile.find('<CONTINENTS>')]
    data_continents = transfile[transfile.find('<CONTINENTS>'):transfile.find('<MAP_TYPES>')]
    data_maptypes = transfile[transfile.find('<MAP_TYPES>'):transfile.find('TOOLTIPS')]
    data_tooltips = transfile[transfile.find('<TOOLTIPS>'):transfile.find('<SKY_CONDITIONS>')]
    data_sky = transfile[transfile.find('<SKY_CONDITIONS>'):transfile.find('<DROPDOWNS>')]
    data_dropdowns = transfile[transfile.find('<DROPDOWNS>'):transfile.find('<WEEKDAYS>')]
    data_weekdays = transfile[transfile.find('<WEEKDAYS>'):transfile.find('<DIALOGS>')]
    data_dialogs = transfile[transfile.find('<DIALOGS>'):]
    
    #Creating translation dictionaries
    
    #Menus first
    
    p = re.compile('</eng>.+')
    base_menu = p.findall(data_configmenu)
    for i in range(len(base_menu)):
        base_menu[i] = base_menu[i].replace('</eng>','')
    
    p = re.compile('</trans>.+')
    trans_menu = p.findall(data_configmenu)
    for i in range(len(trans_menu)):
        trans_menu[i] = trans_menu[i].replace('</trans>','')
    
    transmenu_dict = {}
    for i in range(len(base_menu)):
        transmenu_dict[base_menu[i]] = trans_menu[i]
    # Continents
    
    p = re.compile('</eng>.+')
    base_cont = p.findall(data_continents)
    for i in range(len(base_cont)):
        base_cont[i] = base_cont[i].replace('</eng>','')
    
    p = re.compile('</trans>.+')
    trans_cont = p.findall(data_continents)
    for i in range(len(trans_cont)):
        trans_cont[i] = trans_cont[i].replace('</trans>','')
    
    transcont_dict = {}
    for i in range(len(base_cont)):
        transcont_dict[base_cont[i]] = trans_cont[i]
    # Map types
    
    p = re.compile('</eng>.+')
    base_map = p.findall(data_maptypes)
    for i in range(len(base_map)):
        base_map[i] = base_map[i].replace('</eng>','')
    
    p = re.compile('</trans>.+')
    trans_map = p.findall(data_maptypes)
    for i in range(len(trans_map)):
        trans_map[i] = trans_map[i].replace('</trans>','')
    
    transmap_dict = {}
    for i in range(len(base_map)):
        transmap_dict[base_map[i]] = trans_map[i]
    
    #Dropdowns
    p = re.compile('</eng>.+')
    base_menu = p.findall(data_dropdowns)
    for i in range(len(base_menu)):
        base_menu[i] = base_menu[i].replace('</eng>','')
    
    p = re.compile('</trans>.+')
    trans_menu = p.findall(data_dropdowns)
    for i in range(len(trans_menu)):
        trans_menu[i] = trans_menu[i].replace('</trans>','')
    
    transdrop_dict = {}
    for i in range(len(base_menu)):
        transdrop_dict[base_menu[i]] = trans_menu[i]
    #Tooltips
    
    p = re.compile('</eng>.+')
    base_tool = p.findall(data_tooltips)
    for i in range(len(base_tool)):
        base_tool[i] = base_tool[i].replace('</eng>','')
    
    p = re.compile('</trans>.+')
    trans_tool = p.findall(data_tooltips)
    for i in range(len(trans_tool)):
        trans_tool[i] = trans_tool[i].replace('</trans>','')
    transtool_dict = {}
    for i in range(len(base_tool)):
        transtool_dict[base_tool[i]] = trans_tool[i]
    #Sky
    
    p = re.compile('</eng>.+')
    base_menu = p.findall(data_sky)
    for i in range(len(base_menu)):
        base_menu[i] = base_menu[i].replace('</eng>','')
    
    p = re.compile('</trans>.+')
    trans_menu = p.findall(data_sky)
    for i in range(len(trans_menu)):
        trans_menu[i] = trans_menu[i].replace('</trans>','')
    
    transsky_dict = {}
    for i in range(len(base_menu)):
        transsky_dict[base_menu[i]] = trans_menu[i]
    #Weekdays
    
    p = re.compile('</eng>.+')
    base_menu = p.findall(data_weekdays)
    for i in range(len(base_menu)):
        base_menu[i] = base_menu[i].replace('</eng>','')
    
    p = re.compile('</trans>.+')
    trans_menu = p.findall(data_weekdays)
    for i in range(len(trans_menu)):
        trans_menu[i] = trans_menu[i].replace('</trans>','')
    
    transweek_dict = {}
    for i in range(len(base_menu)):
        transweek_dict[base_menu[i]] = trans_menu[i]
    print transweek_dict
    #Dialogs
    
    p = re.compile('</eng>.+')
    base_menu = p.findall(data_dialogs)
    for i in range(len(base_menu)):
        base_menu[i] = base_menu[i].replace('</eng>','')
    
    p = re.compile('</trans>.+')
    trans_menu = p.findall(data_dialogs)
    for i in range(len(trans_menu)):
        trans_menu[i] = trans_menu[i].replace('</trans>','')
    
    transdial_dict = {}
    for i in range(len(base_menu)):
        transdial_dict[base_menu[i]] = trans_menu[i]
    print transdial_dict

# Basic function to reduce amount of typing necessary to draw text
def prettyText(widget, size, font, shadowflag, textname):
    global dropdownflag
    karamba.changeTextSize(widget, textname, size)
    karamba.changeTextFont(widget, textname, font)
    karamba.changeTextShadow(widget, textname, shadowflag)
    if dropdownflag == 0:
        karamba.changeTextColor(widget, textname, red, green, blue)
    else:
        karamba.changeTextColor(widget, textname, reddrop, greendrop, bluedrop)

# A set of functions to display data/images on roll-down panels
def showSatPic(widget):
    global satpic, satpicon, webbypicbg
    webbypicbg = karamba.createImage(widget, 23, 25, 'webcambg.png')
    karamba.resizeImage(widget, webbypicbg, 216, 0)
    satpic = karamba.createImage(widget, 35, 34, satfile)
    karamba.attachClickArea(widget, satpic)
    karamba.resizeImage(widget, satpic, 190, 20)
    karamba.redrawWidget(widget)
    xpos = 179
    ypos = 35
    for i in range(20,140,10):
        karamba.resizeImage(widget, satpic, 190, i)
        if ypos > 12:
            ypos = ypos - 2
            karamba.moveImage(widget, satbutt, xpos, ypos)
        karamba.redrawWidget(widget)
    karamba.resizeImage(widget, satpic, 190, 140)
    karamba.resizeImage(widget, webbypicbg, 216, 166)
    karamba.redrawWidget(widget)
    satpicon = 1

def removeSatPic(widget):
    global satpicon
    karamba.deleteImage(widget, webbypicbg)
    xpos = 179
    ypos = 12
    for i in range(140,20,-10):
        karamba.resizeImage(widget, satpic, 190, i)
        if ypos < 35:
            ypos = ypos + 2
            karamba.moveImage(widget, satbutt, xpos, ypos)
        karamba.redrawWidget(widget)
    karamba.moveImage(widget, satbutt, 179, 36)
    karamba.deleteImage(widget, satpic)
    karamba.redrawWidget(widget)
    satpicon = 0

##~ def showSumPic(widget):
##~     global sumpic, sumpicon, webbypicbg
##~     webbypicbg = karamba.createImage(widget, 23, 25, 'webcambg.png')
##~     karamba.resizeImage(widget, webbypicbg, 216, 0)
##~     sumpic = karamba.createImage(widget, 35, 34, installed + "/summap.jpg")
##~     karamba.attachClickArea(widget, sumpic)
##~     karamba.resizeImage(widget, sumpic, 190, 20)
##~     karamba.redrawWidget(widget)
##~     xpos = 179
##~     ypos = 36
##~     for i in range(20,140,10):
##~         karamba.resizeImage(widget, sumpic, 190, i)
##~         if ypos > 12:
##~             ypos = ypos - 2
##~             karamba.moveImage(widget, satbutt, xpos, ypos)
##~         karamba.redrawWidget(widget)
##~     karamba.resizeImage(widget, sumpic, 190, 140)
##~     karamba.resizeImage(widget, webbypicbg, 216, 166)
##~     karamba.redrawWidget(widget)
##~     sumpicon = 1
##~ 
##~ def removeSumPic(widget):
##~     global sumpicon
##~     karamba.deleteImage(widget, webbypicbg)
##~     xpos = 179
##~     ypos = 12
##~     for i in range(140,20,-10):
##~         karamba.resizeImage(widget, sumpic, 190, i)
##~         if ypos < 40:
##~             ypos = ypos + 2
##~             karamba.moveImage(widget, satbutt, xpos, ypos)
##~         karamba.redrawWidget(widget)
##~     karamba.moveImage(widget, satbutt, 179, 36)
##~     karamba.deleteImage(widget, sumpic)
##~     karamba.redrawWidget(widget)
##~     sumpicon = 0
##~ 
##~ def showPressPic(widget):
##~     global presspic, presspicon, webbypicbg
##~     webbypicbg = karamba.createImage(widget, 23, 25, 'webcambg.png')
##~     karamba.resizeImage(widget, webbypicbg, 216, 0)
##~     presspic = karamba.createImage(widget, 35, 34, installed + "/pressmap.jpg")
##~     karamba.attachClickArea(widget, presspic)
##~     karamba.resizeImage(widget, presspic, 190, 20)
##~     karamba.redrawWidget(widget)
##~     xpos = 179
##~     ypos = 36
##~     for i in range(20,140,10):
##~         karamba.resizeImage(widget, presspic, 190, i)
##~         if ypos > 12:
##~             ypos = ypos - 2
##~             karamba.moveImage(widget, satbutt, xpos, ypos)
##~         karamba.redrawWidget(widget)
##~     karamba.resizeImage(widget, presspic, 190, 140)
##~     karamba.resizeImage(widget, webbypicbg, 216, 166)
##~     karamba.redrawWidget(widget)
##~     presspicon = 1
##~ 
##~ def removePressPic(widget):
##~     global presspicon
##~     karamba.deleteImage(widget, webbypicbg)
##~     xpos = 179
##~     ypos = 12
##~     for i in range(140,20,-10):
##~         karamba.resizeImage(widget, presspic, 190, i)
##~         if ypos < 40:
##~             ypos = ypos + 2
##~             karamba.moveImage(widget, satbutt, xpos, ypos)
##~         karamba.redrawWidget(widget)
##~     karamba.moveImage(widget, satbutt, 179, 36)
##~     karamba.deleteImage(widget, presspic)
##~     karamba.redrawWidget(widget)
##~     presspicon = 0

def showWebcamPic(widget):
    global webbypic, webpicon, webbypicbg
    webbypicbg = karamba.createImage(widget, 23, 25, 'webcambg.png')
    karamba.resizeImage(widget, webbypicbg, 216, 0)
    webbypic = karamba.createImage(widget, 35, 34, filenames[webcamdisplay])
    karamba.resizeImage(widget, webbypic, 190, 20)
    karamba.redrawWidget(widget)
    xpos = 203
    ypos = 36
    for i in range(20,140,10):
        karamba.resizeImage(widget, webbypic, 190, i)
        if ypos > 12:
            ypos = ypos - 2
            karamba.moveImage(widget, cambutt, xpos, ypos)
        karamba.redrawWidget(widget)
    karamba.resizeImage(widget, webbypic, 190, 140)
    karamba.resizeImage(widget, webbypicbg, 216, 166)
    karamba.redrawWidget(widget)
    webpicon = 1

def removeWebcamPic(widget):
    global webpicon
    karamba.deleteImage(widget, webbypicbg)
    xpos = 203
    ypos = 12
    for i in range(140,20,-10):
        karamba.resizeImage(widget, webbypic, 190, i)
        if ypos < 35:
            ypos = ypos + 2
            karamba.moveImage(widget, cambutt, xpos, ypos)
        karamba.redrawWidget(widget)
    karamba.deleteImage(widget, webbypic)
    karamba.moveImage(widget, cambutt, 203, 36)
    karamba.redrawWidget(widget)
    webpicon = 0

def createBBCDayDetail(widget, day):
    global weather, order, separator, ddbg, ddmainpic, setday, settemp, setwind, setsitu, setsun, sethumi, setvisi, setpress, ddday, ddtemp, ddwind, ddcwstr, ddsitu, ddon, ddsunrise, ddsunset, ddhumi, ddvisi, ddpress, daypicrem, topBar, daypicpos, animate, dropdownflag
    situtext = transsky_dict.get(weather.get_forecast(day).sky())
    dropdownflag = 1
    if situtext == None:
        situtext = weather.get_forecast(day).sky()
        transError(widget, weather.get_forecast(day).sky())
    if altback == 1:
        ddbg = karamba.createImage(widget, 26, 25, "background/dd_bg9.png")
    if altback == 2:
        ddbg = karamba.createImage(widget, 26, 25, "background/dd_bg17.png")
    elif flatflag == 1:
        ddbg = karamba.createImage(widget, 26, 25, "background/dd_bgflat.png")
    else:
        ddbg = karamba.createImage(widget, 26, 25, "background/dd_bg.png")
    karamba.resizeImage(widget, ddbg, 210, 20)
    karamba.changeImageIntensity(widget, daypicrem[day], 0.3, 0)
    karamba.redrawWidget(widget)
    flag = 0
    xpos = (daypicpos[day])
    ypos = 140
    height = 28
    width = 28
    deg = 30
    for i in range(20,140,10):
        karamba.resizeImage(widget, ddbg, 210, i)
        if animate == 0:
            karamba.rotateImage(widget, daypicrem[day], deg)
            w = karamba.getImageWidth(widget,daypicrem[day])
            h = karamba.getImageHeight(widget,daypicrem[day])
            karamba.moveImage(widget, daypicrem[day], xpos-((w-width)/2), ypos-((h-height)/2))
            deg = deg + 30
        karamba.redrawWidget(widget)
    
#    iconsettest = karamba.readConfigEntry(widget, "iconset")
#    if (iconsettest != None):
#        iconsetpath = 'icons/' + iconsettest + '/'

    ddmainpic = karamba.createImage(widget, 135, 35, iconsetpath + weather.get_forecast(day).large_icon_path())
    setday = karamba.createText(widget, 50, 30, 100, 20, transdrop_dict.get('Detail For:'))
    prettyText(widget, 17, "verdana", shadow, setday)
    ddday = karamba.createText(widget, 150, 30, 70, 20, transweek_dict.get(weather.get_forecast(day).weekday()))
    prettyText(widget, 17, "verdana", shadow, ddday)
    settemp = karamba.createText(widget, 50, 52, 70, 20, transdrop_dict.get('Temp:'))
    prettyText(widget, 10, "verdana", shadow, settemp)
    setwind = karamba.createText(widget, 50, 64, 70, 20, transdrop_dict.get('Wind:'))
    prettyText(widget, 10, "verdana", shadow, setwind)
    setsitu = karamba.createText(widget, 50, 76, 70, 20, transdrop_dict.get('Sky:'))
    prettyText(widget, 10, "verdana", shadow, setsitu)
    setsun = karamba.createText(widget, 50, 88, 70, 20, transdrop_dict.get('Sun:'))
    prettyText(widget, 10, "verdana", shadow, setsun)
    sethumi = karamba.createText(widget, 50, 100, 70, 20, transdrop_dict.get('Humi:'))
    prettyText(widget, 10, "verdana", shadow, sethumi)
    setvisi = karamba.createText(widget, 50, 112, 70, 20, transdrop_dict.get('Visi:'))
    prettyText(widget, 10, "verdana", shadow, setvisi)
    setpress = karamba.createText(widget, 50, 124, 70, 20, transdrop_dict.get('Pres:'))
    prettyText(widget, 10, "verdana", shadow, setpress)
    ddtemp = karamba.createText(widget, 85, 52, 130, 20, weather.get_forecast(day).temperature_range(order, separator))
    prettyText(widget, 10, "verdana", shadow, ddtemp)
    ddwind = karamba.createText(widget, 85, 64, 50, 20, weather.get_forecast(day).wind())
    prettyText(widget, 10, "verdana", shadow, ddwind)
    ddcwstr = karamba.createText(widget, 105, 64, 50, 20, weather.get_forecast(day).wind_speed())
    prettyText(widget, 10, "verdana", shadow, ddcwstr)
    ddsitu = karamba.createText(widget, 85, 76, 130, 20, situtext)
    prettyText(widget, 10, "verdana", shadow, ddsitu)
    ddsunrise = karamba.createText(widget, 85, 88, 130, 20, weather.get_forecast(day).sunrise())
    prettyText(widget, 10, "verdana", shadow, ddsunrise)
    ddsunset = karamba.createText(widget, 120, 88, 130, 20, weather.get_forecast(day).sunset())
    prettyText(widget, 10, "verdana", shadow, ddsunset)
    ddhumi = karamba.createText(widget, 85, 100, 130, 20, weather.get_forecast(day).humidity())
    prettyText(widget, 10, "verdana", shadow, ddhumi)
    ddvisi = karamba.createText(widget, 85, 112, 130, 20, weather.get_forecast(day).visibility())
    prettyText(widget, 10, "verdana", shadow, ddvisi)
    ddpress = karamba.createText(widget, 85, 124, 130, 20, weather.get_forecast(day).pressure())
    prettyText(widget, 10, "verdana", shadow, ddpress)
    ddon = 1
    dropdownflag = 0


def deleteBBCDayDetail(widget, day):
    global ddon, ddbg, ddmainpic, setday, settemp, setwind, setsitu, setsun, sethumi, setvisi, setpress, ddday, ddtemp, ddwind, ddcwstr, ddsitu, ddsunrise, ddsunset, ddhumi, ddvisi, ddpress, daypicrem, topBar, daypicpos, animate, otherdetail
    for i in (setday, settemp, setwind, setsitu, setsun, sethumi, setvisi, setpress, ddday, ddtemp, ddwind, ddcwstr, ddsitu, ddsunrise, ddsunset, ddhumi, ddvisi, ddpress):
        karamba.deleteText(widget, i)
    karamba.deleteImage(widget, ddmainpic)
    karamba.redrawWidget(widget)
    flag = 0
    xpos = (daypicpos[day])
    ypos = 140
    height = 28
    width = 28
    deg = 330
    for i in range(130,20,-10):
        karamba.resizeImage(widget, ddbg, 210, i)
        if animate == 0:
            karamba.rotateImage(widget, daypicrem[day], deg)
            w = karamba.getImageWidth(widget,daypicrem[day])
            h = karamba.getImageHeight(widget,daypicrem[day])
            karamba.moveImage(widget, daypicrem[day], xpos-((w-width)/2), ypos-((h-height)/2))
            deg = deg - 30
        karamba.redrawWidget(widget)
    karamba.moveImage(widget, daypicrem[day], xpos, ypos)
    karamba.redrawWidget(widget)
    karamba.deleteImage(widget, ddbg)
    #if animate == 0:
        #karamba.resizeImage(widget, daypicrem[day], 28, 28)
        #karamba.moveImage(widget, daypicrem[day], daypicpos[day], 140)
    karamba.removeImageTransformations(widget, daypicrem[day])
    karamba.redrawWidget
    ddon = 0
    otherdetail = 1

def createWcomDayDetail(widget, day):
    global weather, order, separator, ddbg, setday, settemp, setrain, setsitu, ddday, ddtemp, ddrain, ddsitu, ddon, setdate, dddate, daypicrem, topBar, daypicpos, animate, ddmainpic, dropdownflag
    situtext = transsky_dict.get(weather.get_forecast(day).sky())
    dropdownflag = 1
    if situtext == None:
        situtext = weather.get_forecast(day).sky()
        transError(widget, weather.get_forecast(day).sky())
    if altback == 1:
        ddbg = karamba.createImage(widget, 26, 25, "background/dd_bg9.png")
    if altback == 2:
        ddbg = karamba.createImage(widget, 26, 25, "background/dd_bg17.png")
    elif flatflag == 1:
        ddbg = karamba.createImage(widget, 26, 25, "background/dd_bgflat.png")
    else:
        ddbg = karamba.createImage(widget, 26, 25, "background/dd_bg.png")
    karamba.resizeImage(widget, ddbg, 210, 20)
    karamba.changeImageIntensity(widget, daypicrem[day], 0.3, 0)
    karamba.redrawWidget(widget)
    flag = 0
    xpos = (daypicpos[day])
    ypos = 140
    height = 28
    width = 28
    deg = 30
    for i in range(20,140,10):
        karamba.resizeImage(widget, ddbg, 210, i)
        if animate == 0:
            karamba.rotateImage(widget, daypicrem[day], deg)
            w = karamba.getImageWidth(widget,daypicrem[day])
            h = karamba.getImageHeight(widget,daypicrem[day])
            karamba.moveImage(widget, daypicrem[day], xpos-((w-width)/2), ypos-((h-height)/2))
            deg = deg + 30
        karamba.redrawWidget(widget)

    ddmainpic = karamba.createImage(widget, 135, 35, iconsetpath + weather.get_forecast(day).large_icon_path())
    setday = karamba.createText(widget, 50, 30, 100, 20, transdrop_dict.get('Detail For:'))
    prettyText(widget, 17, "verdana", shadow, setday)
    print weather.get_forecast(day).weekday()
    ddday = karamba.createText(widget, 150, 30, 70, 20, transweek_dict.get(weather.get_forecast(day).weekday()))
    prettyText(widget, 17, "verdana", shadow, ddday)
    setdate = karamba.createText(widget, 50, 60, 70, 20, transdrop_dict.get('Date:'))
    prettyText(widget, 10, "verdana", shadow, setdate)
    settemp = karamba.createText(widget, 50, 80, 70, 20, transdrop_dict.get('Temp:'))
    prettyText(widget, 10, "verdana", shadow, settemp)
    setrain = karamba.createText(widget, 50, 100, 70, 20, transdrop_dict.get('Rain:'))
    prettyText(widget, 10, "verdana", shadow, setrain)
    setsitu = karamba.createText(widget, 50, 120, 70, 20, transdrop_dict.get('Sky:'))
    prettyText(widget, 10, "verdana", shadow, setsitu)
    dddate = karamba.createText(widget, 85, 60, 50, 20, weather.get_forecast(day).date())
    prettyText(widget, 10, "verdana", shadow, dddate)
    ddtemp = karamba.createText(widget, 85, 80, 130, 20, weather.get_forecast(day).temperature_range(order, separator))
    prettyText(widget, 10, "verdana", shadow, ddtemp)
    ddrain = karamba.createText(widget, 85, 100, 50, 20, weather.get_forecast(day).rain())
    prettyText(widget, 10, "verdana", shadow, ddrain)
    ddsitu = karamba.createText(widget, 85, 120, 130, 20, situtext)
    prettyText(widget, 10, "verdana", shadow, ddsitu)
    ddon = 1
    dropdownflag = 0


def deleteWcomDayDetail(widget, day):
    global ddon, ddbg, setday, settemp, setrain, setsitu, ddday, ddtemp, ddrain, ddsitu, dddate, setdate, daypicrem, topBar, daypicpos, animate, otherdetail
    for i in (setday, settemp, setrain, setsitu, setdate, ddday, ddtemp, ddrain, ddsitu, dddate):
        karamba.deleteText(widget, i)
    karamba.deleteImage(widget, ddmainpic)
    karamba.redrawWidget(widget)
    flag = 0
    xpos = (daypicpos[day])
    ypos = 140
    height = 28
    width = 28
    deg = 330
    for i in range(130,20,-10):
        karamba.resizeImage(widget, ddbg, 210, i)
        if animate == 0:
            karamba.rotateImage(widget, daypicrem[day], deg)
            w = karamba.getImageWidth(widget,daypicrem[day])
            h = karamba.getImageHeight(widget,daypicrem[day])
            karamba.moveImage(widget, daypicrem[day], xpos-((w-width)/2), ypos-((h-height)/2))
            deg = deg - 30
        karamba.redrawWidget(widget)
    karamba.moveImage(widget, daypicrem[day], xpos, ypos)
    karamba.redrawWidget(widget)
    karamba.deleteImage(widget, ddbg)
    #if animate == 0:
        #karamba.resizeImage(widget, daypicrem[day], 28, 28)
        #karamba.moveImage(widget, daypicrem[day], daypicpos[day], 140)
    karamba.removeImageTransformations(widget, daypicrem[day])
    karamba.redrawWidget
    ddon = 0
    otherdetail = 1
    
def createCurrentDetail(widget):
    global clock, weather, ddcbg, setcday, setccity, setcdate, setctime, setcwdir, setcwstr, setcbar, setcrtmp, setchum, setcvis, setcuv, ddcday, ddccity, ddcdate, ddctime, ddcwdir, ddcwstr, ddcbar, ddcvis, ddcuv, ddcon, mainpic, clicky, animate, webpicon, dropdownflag
    dropdownflag = 1
    if altback == 1:
        ddcbg = karamba.createImage(widget, 33, 25, "background/ddc_bg9.png")
    elif altback == 2:
        ddcbg = karamba.createImage(widget, 33, 25, "background/ddc_bg17.png")
    elif flatflag == 1:
        ddcbg = karamba.createImage(widget, 33, 25, "background/ddc_bgflat.png")
    else:
        ddcbg = karamba.createImage(widget, 33, 25, "background/ddc_bg.png")
    karamba.resizeImage(widget, ddcbg, 196, 20)
    karamba.changeImageIntensity(widget, mainpic, 0.3, 0)
    karamba.redrawWidget(widget)
    #x = 108
    #y = 108
    deg = 36
    height = 120
    width = 120
    for i in range(10,140,13):
        karamba.resizeImage(widget, ddcbg, 196, i)
        if animate == 0:
            #karamba.resizeImage(widget, mainpic, x, y)
            karamba.rotateImage(widget, mainpic, deg)
            w = karamba.getImageWidth(widget,mainpic)
            h = karamba.getImageHeight(widget,mainpic)
            karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
            deg = deg + 36
        karamba.redrawWidget(widget)
        #x = x - 8
        #y = y - 8
    karamba.resizeImage(widget, ddcbg, 196, 136)
    #if animate == 0:
        #karamba.resizeImage(widget, mainpic, 40, 40)
    karamba.redrawWidget(widget)
    setcday = karamba.createText(widget, 50, 30, 200, 20, transdrop_dict.get('Current Situation:'))
    prettyText(widget, 17, "verdana", shadow, setcday)
    setccity = karamba.createText(widget, 50, 47, 70, 20, transdrop_dict.get('City:'))
    prettyText(widget, 10, "verdana", shadow, setccity)
    setctime = karamba.createText(widget, 50, 59, 70, 20, transdrop_dict.get('Check:'))
    prettyText(widget, 10, "verdana", shadow, setctime)
    setcdate = karamba.createText(widget, 50, 71, 70, 20, transdrop_dict.get('Date:'))
    prettyText(widget, 10, "verdana", shadow, setcdate)
    setcwdir = karamba.createText(widget, 50, 83, 70, 20, transdrop_dict.get('Wind:'))
    prettyText(widget, 10, "verdana", shadow, setcwdir)
    setcwstr = karamba.createText(widget, 50, 95, 70, 20, transdrop_dict.get('Speed:'))
    prettyText(widget, 10, "verdana", shadow, setcwstr)
    setcbar = karamba.createText(widget, 50, 107, 70, 20, transdrop_dict.get('PChange:'))
    prettyText(widget, 10, "verdana", shadow, setcbar)
    setcvis = karamba.createText(widget, 50, 119, 70, 20, transdrop_dict.get('Visibility:'))
    prettyText(widget, 10, "verdana", shadow, setcvis)
    setcuv = karamba.createText(widget, 50, 131, 70, 20, transdrop_dict.get('UV:'))
    prettyText(widget, 10, "verdana", shadow, setcuv)
#     ddcday = karamba.createText(widget, 150, 30, 100, 20, "Today " + weather.weekday())
#     prettyText(widget, 17, "verdana", ddcday)
    ddccity = karamba.createText(widget, 105, 47, 120, 20, weather.place())
    prettyText(widget, 10, "verdana", shadow, ddccity)

    # showing 24h clock?
    if clock: tmptimestr = weather.time()
    else:  tmptimestr = weather.get_12h_time()
    tmptimestr +=  ' ' + weather.timezone()
    ddctime = karamba.createText(widget, 105, 59, 100, 20, tmptimestr)
    prettyText(widget, 10, "verdana", shadow, ddctime)
    ddcdate = karamba.createText(widget, 105, 71, 100, 20, weather.day() + " " + weather.month() + " " + weather.year())
    prettyText(widget, 10, "verdana", shadow, ddcdate)
    ddcwdir = karamba.createText(widget, 105, 83, 120, 20, weather.wind())
    prettyText(widget, 10, "verdana", shadow, ddcwdir)
    ddcwstr = karamba.createText(widget, 105, 95, 70, 20, weather.wind_speed())
    prettyText(widget, 10, "verdana", shadow, ddcwstr)
    ddcbar = karamba.createText(widget, 105, 107, 70, 20, weather.pressure_change())
    prettyText(widget, 10, "verdana", shadow, ddcbar)
    ddcvis = karamba.createText(widget, 105, 119, 70, 20, weather.visibility())
    prettyText(widget, 10, "verdana", shadow, ddcvis)
    ddcuv = karamba.createText(widget, 105, 131, 70, 20, weather.uv())
    prettyText(widget, 10, "verdana", shadow, ddcuv)
    ddcon = 1
    dropdownflag = 0

def deleteCurrentDetail(widget):
    global ddcbg, setcday, setcdate, setctime, setcwdir, setcwstr, setcbar, setcvis, setcuv, ddcday, ddcdate, ddctime, ddcwdir, ddcwstr, ddcbar, ddcvis, ddcuv, ddcon, mainpic, animate, otherdetail
    for i in (setcday, setcdate, setccity, setctime, setcwdir, setcwstr, setcbar, setcvis, setcuv, ddcdate, ddccity, ddctime, ddcwdir, ddcwstr, ddcbar, ddcvis, ddcuv):
        karamba.deleteText(widget, i)
    karamba.redrawWidget(widget)
    #x = 40
    #y = 40
    height = 120
    width = 120
    deg = -36
    for i in range(136,10,-13):
        karamba.resizeImage(widget, ddcbg, 196, i)
        if animate == 0:
            #karamba.resizeImage(widget, mainpic, x, y)
            karamba.rotateImage(widget, mainpic, deg)
            w = karamba.getImageWidth(widget,mainpic)
            h = karamba.getImageHeight(widget,mainpic)
            karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
            deg = deg - 36
        karamba.redrawWidget(widget)
        #x = x + 8
        #y = y + 8
    karamba.deleteImage(widget, ddcbg)
    #if animate == 0:
        #karamba.resizeImage(widget, mainpic, 120, 120)
    karamba.removeImageTransformations(widget, mainpic)
    karamba.redrawWidget
    ddcon = 0
    otherdetail = 1

def createHourlyDetail1(widget):
    global hourly, hbg, mainpic, clicky, animate, hon, sub_hour_rem, main_hour_rem, pic_hour_rem, headtime, headicon, headtemp, headrain, headwind, firsthour, headpage, dropdownflag
    dropdownflag = 1
    if altback == 1:
        hbg = karamba.createImage(widget, 0, 0, "background/ddc_bg9.png")
    if altback == 2:
        hbg = karamba.createImage(widget, 0, 0, "background/ddc_bg17.png")
    elif flatflag == 1:
        hbg = karamba.createImage(widget, 0, 0, "background/ddc_bgflat.png")
    else:
        hbg = karamba.createImage(widget, 0, 0, "background/h_bg.png")
    karamba.resizeImage(widget, hbg, 250, 20)
    karamba.changeImageIntensity(widget, mainpic, 0.3, 0)
    karamba.redrawWidget(widget)
    #x = 108
    #y = 108
    deg = 36
    height = 120
    width = 120
    for i in range(10,200,10):
        karamba.resizeImage(widget, hbg, 250, i)
        if animate == 0:
            #karamba.resizeImage(widget, mainpic, x, y)
            karamba.rotateImage(widget, mainpic, deg)
            w = karamba.getImageWidth(widget,mainpic)
            h = karamba.getImageHeight(widget,mainpic)
            karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
            deg = deg + 36
        karamba.redrawWidget(widget)
        #x = x - 8
        #y = y - 8
    karamba.resizeImage(widget, hbg, 250, 200)
    headtime = karamba.createText(widget, 10, 10, 70, 20, transtool_dict.get("Time"))
    prettyText(widget, 10, "arial black", shadow, headtime)
    headicon = karamba.createText(widget, 50, 10, 70, 20, transtool_dict.get("Sky"))
    prettyText(widget, 10, "arial black", shadow, headicon)
    headtemp = karamba.createText(widget, 84, 10, 70, 20, transtool_dict.get("Temp"))
    prettyText(widget, 10, "arial black", shadow, headtemp)
    headrain = karamba.createText(widget, 118, 10, 70, 20, transtool_dict.get("Rain"))
    prettyText(widget, 10, "arial black", shadow, headrain)
    headwind = karamba.createText(widget, 178, 10, 70, 20, transtool_dict.get("Wind"))
    prettyText(widget, 10, "arial black", shadow, headwind)
    headpage = karamba.createText(widget, 218, 10, 70, 20, '(1/2)')
    prettyText(widget, 10, "arial black", shadow, headpage)
    current_time = weather.time()
    cur_time_ind = current_time.find(':')
    current_time = int(current_time[:cur_time_ind])
    next_time = current_time + 1
    if next_time > 24:
        next_time = next_time - 24
    ypos = 38
    main_hour_rem = []
    sub_hour_rem = []
    pic_hour_rem = []
    for i in range(6):
        hourtime = karamba.createText(widget, 10, ypos, 70, 20, str(next_time) + ':00')
        prettyText(widget, 10, "verdana", shadow, hourtime)
        sub_hour_rem.append(hourtime)
        houricon = karamba.createImage(widget, 50, ypos - 10, path + iconsetpath + hourly.get_forecast(i).icon_path())
        situtext = transsky_dict.get(hourly.get_forecast(i).sky())
        if situtext == None:
            situtext = hourly.get_forecast(i).sky()
            transError(widget, hourly.get_forecast(i).sky())
        hourtooltip = karamba.addImageTooltip(widget, houricon, situtext)
        pic_hour_rem.append(houricon)
        hourtemp = karamba.createText(widget, 84, ypos, 70, 20, hourly.get_forecast(i).temperature_high())
        prettyText(widget, 10, "verdana", shadow, hourtemp)
        sub_hour_rem.append(hourtemp)
        hourrain = karamba.createText(widget, 118, ypos, 70, 20, hourly.get_forecast(i).rain())
        prettyText(widget, 10, "verdana", shadow, hourrain)
        sub_hour_rem.append(hourrain)
        hourwind = karamba.createText(widget, 158, ypos, 70, 20, hourly.get_forecast(i).wind())
        prettyText(widget, 10, "verdana", shadow, hourwind)
        sub_hour_rem.append(hourwind)
        hourspeed = karamba.createText(widget, 188, ypos, 70, 20, hourly.get_forecast(i).wind_speed())
        prettyText(widget, 10, "verdana", shadow, hourspeed)
        sub_hour_rem.append(hourspeed)
        ypos = ypos + 28
        next_time = next_time + 1
        if next_time > 24:
            next_time = next_time - 24
        main_hour_rem.append(sub_hour_rem)
        sub_hour_rem = []
        hon = 1
    dropdownflag = 0
    
def deleteHourlyDetail1(widget):
    global hon, mainpic, animate, otherdetail
    headings = [headtime, headicon, headtemp, headrain, headwind, headpage]
    for i in headings:
        karamba.deleteText(widget, i)
    for i in range(6):
        for j in range(5):
            karamba.deleteText(widget, main_hour_rem[i][j])
        karamba.deleteImage(widget, pic_hour_rem[i])
    karamba.redrawWidget(widget)
    #x = 40
    #y = 40
    height = 120
    width = 120
    deg = -36
    for i in range(136,10,-13):
        karamba.resizeImage(widget, hbg, 250, i)
        if animate == 0:
            #karamba.resizeImage(widget, mainpic, x, y)
            karamba.rotateImage(widget, mainpic, deg)
            w = karamba.getImageWidth(widget,mainpic)
            h = karamba.getImageHeight(widget,mainpic)
            karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
            deg = deg - 36
        karamba.redrawWidget(widget)
        #x = x + 8
        #y = y + 8
    karamba.deleteImage(widget, hbg)
    #if animate == 0:
        #karamba.resizeImage(widget, mainpic, 120, 120)
    karamba.removeImageTransformations(widget, mainpic)
    karamba.redrawWidget
    hon = 0
    firsthour = 1
    otherdetail = 0

def createHourlyDetail2(widget):
    global hourly, hbg2, mainpic, clicky, animate, hon2, sub_hour_rem2, main_hour_rem2, pic_hour_rem2, headtime2, headicon2, headtemp2, headrain2, headwind2, headpage2, dropdownflag
    dropdownflag = 1
    if altback == 1:
        hbg2 = karamba.createImage(widget, 0, 0, "background/ddc_bg9.png")
    if altback == 2:
        hbg2 = karamba.createImage(widget, 0, 0, "background/ddc_bg17.png")
    elif flatflag == 1:
        hbg2 = karamba.createImage(widget, 0, 0, "background/ddc_bgflat.png")
    else:
        hbg2 = karamba.createImage(widget, 0, 0, "background/h_bg.png")
    karamba.resizeImage(widget, hbg2, 250, 20)
    karamba.changeImageIntensity(widget, mainpic, 0.3, 0)
    karamba.redrawWidget(widget)
    #x = 108
    #y = 108
    deg = 36
    height = 120
    width = 120
    for i in range(10,200,10):
        karamba.resizeImage(widget, hbg2, 250, i)
        if animate == 0:
            #karamba.resizeImage(widget, mainpic, x, y)
            karamba.rotateImage(widget, mainpic, deg)
            w = karamba.getImageWidth(widget,mainpic)
            h = karamba.getImageHeight(widget,mainpic)
            karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
            deg = deg + 36
        karamba.redrawWidget(widget)
        #x = x - 8
        #y = y - 8
    karamba.resizeImage(widget, hbg2, 250, 200)
    headtime2 = karamba.createText(widget, 10, 10, 70, 20, transtool_dict.get("Time"))
    prettyText(widget, 10, "arial black", shadow, headtime2)
    headicon2 = karamba.createText(widget, 50, 10, 70, 20, transtool_dict.get("Sky"))
    prettyText(widget, 10, "arial black", shadow, headicon2)
    headtemp2 = karamba.createText(widget, 84, 10, 70, 20, transtool_dict.get("Temp"))
    prettyText(widget, 10, "arial black", shadow, headtemp2)
    headrain2 = karamba.createText(widget, 118, 10, 70, 20, transtool_dict.get("Rain"))
    prettyText(widget, 10, "arial black", shadow, headrain2)
    headwind2 = karamba.createText(widget, 178, 10, 70, 20, transtool_dict.get("Wind"))
    prettyText(widget, 10, "arial black", shadow, headwind2)
    headpage2 = karamba.createText(widget, 218, 10, 70, 20, '(2/2)')
    prettyText(widget, 10, "arial black", shadow, headpage2)
    current_time2 = weather.time() 
    cur_time_ind2 = current_time2.find(':')
    current_time2 = int(current_time2[:cur_time_ind2])
    next_time2 = current_time2 + 7
    if next_time2 > 24:
        next_time2 = next_time2 - 24
    ypos = 38
    main_hour_rem2 = []
    sub_hour_rem2 = []
    pic_hour_rem2 = []
    for i in range(6,12):
        hourtime2 = karamba.createText(widget, 10, ypos, 70, 20, str(next_time2) + ':00')
        prettyText(widget, 10, "verdana", shadow, hourtime2)
        sub_hour_rem2.append(hourtime2)
        houricon2 = karamba.createImage(widget, 50, ypos - 10, path + iconsetpath + hourly.get_forecast(i).icon_path())
        situtext = transsky_dict.get(hourly.get_forecast(i).sky())
        if situtext == None:
            situtext = hourly.get_forecast(i).sky()
            transError(widget, hourly.get_forecast(i).sky())
        hourtooltip2 = karamba.addImageTooltip(widget, houricon2, hourly.get_forecast(i).sky())
        pic_hour_rem2.append(houricon2)
        hourtemp2 = karamba.createText(widget, 84, ypos, 70, 20, hourly.get_forecast(i).temperature_high())
        prettyText(widget, 10, "verdana", shadow, hourtemp2)
        sub_hour_rem2.append(hourtemp2)
        hourrain2 = karamba.createText(widget, 118, ypos, 70, 20, hourly.get_forecast(i).rain())
        prettyText(widget, 10, "verdana", shadow, hourrain2)
        sub_hour_rem2.append(hourrain2)
        hourwind2 = karamba.createText(widget, 158, ypos, 70, 20, hourly.get_forecast(i).wind())
        prettyText(widget, 10, "verdana", shadow, hourwind2)
        sub_hour_rem2.append(hourwind2)
        hourspeed2 = karamba.createText(widget, 188, ypos, 70, 20, hourly.get_forecast(i).wind_speed())
        prettyText(widget, 10, "verdana", shadow, hourspeed2)
        sub_hour_rem2.append(hourspeed2)
        ypos = ypos + 28
        next_time2 = next_time2 + 1
        if next_time2 > 24:
            next_time2 = next_time2 - 24
        main_hour_rem2.append(sub_hour_rem2)
        sub_hour_rem2 = []
        hon2 = 1
    dropdownflag = 0
        
def deleteHourlyDetail2(widget):
    global hon2, mainpic, animate, otherdetail
    headings = [headtime2, headicon2, headtemp2, headrain2, headwind2, headpage2]
    for i in headings:
        karamba.deleteText(widget, i)
    for i in range(6):
        for j in range(5):
            karamba.deleteText(widget, main_hour_rem2[i][j])
        karamba.deleteImage(widget, pic_hour_rem2[i])
    karamba.redrawWidget(widget)
    #x = 40
    #y = 40
    height = 120
    width = 120
    deg = -36
    for i in range(136,10,-13):
        karamba.resizeImage(widget, hbg2, 250, i)
        if animate == 0:
            #karamba.resizeImage(widget, mainpic, x, y)
            karamba.rotateImage(widget, mainpic, deg)
            w = karamba.getImageWidth(widget,mainpic)
            h = karamba.getImageHeight(widget,mainpic)
            karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
            deg = deg - 36
        karamba.redrawWidget(widget)
        #x = x + 8
        #y = y + 8
    karamba.deleteImage(widget, hbg2)
    #if animate == 0:
        #karamba.resizeImage(widget, mainpic, 120, 120)
    karamba.removeImageTransformations(widget, mainpic)
    karamba.redrawWidget
    hon2 = 0
    otherdetail = 1

# Functions to parse weather data using regular expressions
def parseWeatherData(data, days):
    # Parses an xml page from weather.com and returns a list
    # containing the current weather conditions and forecast.

    # data: An unmodified xml page from weather.com
    # days: Number of forecast days (including today) to return (maximum 10)
    global dnamobst
    import re
    import weather

    # Make sure we don't try to get any more than 5 day's forecast
    if days > 5: days = 5

    # Chop the data into more managable bits, and do a bit of manipulation
    # of data to rectify anomolies between XML and html data
    data = data.replace('CALM', 'Variable')
    data = data.replace('calm', '0')
    data = data.replace('<dewp>N/A</dewp>', '<dewp>0</dewp>')
    #print data
    dnamstart = data.find('<dnam>')
    dnamstop = data.find('</dnam>')
    al_city_match = re.search('<dnam>(?P<city>.*?),', data[dnamstart:dnamstop])
    dcstart = data.find('<cc>')
    dcstop = data.find('</cc>')
    data_current = data[dcstart:dcstop]

    day0 = data.find('<day d="0"')
    day1 = data.find('<day d="1"')
    day2 = data.find('<day d="2"')
    day3 = data.find('<day d="3"')
    day4 = data.find('<day d="4"')
    data0 = data[day0:day1]
    data1 = data[day1:day2]
    data2 = data[day2:day3]
    data3 = data[day3:day4]
    data4 = data[day4:]


    p_report = r'''(?ix)
    .*<lsup>(?P<month>\d+?)/ # Month
    (?P<day>\d+?)/ # Day
    (?P<year>\d+?) # Year
    \s(?P<time>.+?)\s #Time
    (?P<meridian>[A|P]M) # AM or PM
    \s(?P<zone>.*?)</lsup> # time zone
    \s*<obst>(?P<city>.*?), # City
    '''




    # time and location of the weather report
    now = weather.Observation()
    match = re.search(p_report, data_current)
    print match
    #print match.group('city')
    if match:
        now.year(match.group('year'))
        now.month(match.group('month'))
        now.day(match.group('day'))
        now.time(match.group('time'), match.group('meridian'))
        now.timezone(match.group('zone'))
        if al_city_match and dnamobst:
             now.place(al_city_match.group('city'))
        else:
            now.place(match.group('city'))

    p_weekday = r'''(?ix)
    <day\sd=\"0\"\st=\"(?P<weekday>.+?)\" # Day of the week
    '''

    match1 = re.search(p_weekday, data0)
    print match1
    print match1.group('weekday')
    if match1:
        now.weekday(match1.group('weekday')[:3])


    #print now
    print '==================================================='
    p_current = r'''(?isx) # Ignore case, Dot matches all, Verbose
    .*<tmp>(?P<temp>.*?)</tmp> # Temp
    \s*<flik>(?P<heat>.*?)</flik> # Heat
    \s*<t>(?P<sky>\D+?)</t> # Sky
    \s*<icon>(?P<icon>.*?)</icon> # Icon
    \s*<bar>\s*<r>(?P<baro>.*?)</r>\s*<d>(?P<change>.*?)</d>\s*</bar>
    \s*<wind>\s*<s>(?P<speed>.*?)</s>.*<t>(?P<wind>.*?)</t>\s*</wind>
    \s*<hmid>(?P<hum>(.*?|N/A))</hmid>
    \s*<vis>(?P<vis>.*?)</vis>
    \s*<uv>\s*<i>(?P<uv>(.*?|N/A))</i>
    .*<dewp>(?P<dew>(.*?|N/A))</dewp>
    '''


    match = re.search(p_current, data_current)
    print match
    print match.group('wind')
    if match:
        now.icon(match.group('icon'))
        now.temperature(match.group('temp'), 'F')
        now.relative_heat(match.group('heat'), 'F')
        now.sky(match.group('sky'))
        now.uv(match.group('uv'))
        now.dewpoint(match.group('dew'), 'F')
        now.humidity(match.group('hum'))
        now.visibility(match.group('vis'))
        now.pressure(match.group('baro'), 'inHg')
        now.pressure_change(match.group('change'))
        if match.group('wind') != 'CALM':
            mywind =  match.group('wind')
            gusting = mywind.find('gusting')
            if gusting != -1:
                jat = mywind.find(' at')
                mywind = mywind[:jat]
            now.wind(mywind.replace('From the ', ''))
            
        now.wind_speed(match.group('speed'), 'mph')
    print now


    p_today = r'''(?isx) # Ignore case, Dot matches all, Verbose
    <day\sd=\"0\".*dt=\"(?P<date>.*?)\"> # Date
    \s*?<hi>(?P<high>(.*?|N/A))</hi> # High temperature
    \s*?<low>(?P<low>(.*?|N/A))</low> # Low temperature
    .*?<icon>(?P<icon>\d*?)</icon> # Icon
    \s*?<t>(?P<sky>.*?)</t> # Sky
    .*?<ppcp>(?P<rain>\d+)</ppcp>  # Chance of rain
    '''

    today = weather.Forecast(now.weekday())
    now.add_forecast(today)
    match = re.search(p_today, data0)
    print match
    if match:
        today.icon(match.group('icon'))
        today.sky(match.group('sky'))
        today.date(match.group('date'))
        if match.group('high') != 'N/A':
            today.temperature_high(match.group('high'), 'F')
        today.temperature_low(match.group('low'), 'F')
        today.rain(match.group('rain'));

    print "+++++++++++++++++++Today\'s Forecast++++++++++++++++++++++++"
    print today
    p_forecast = r'''(?isx) # No embedded flags, since they will be added later
    .*?t=\"(?P<day>.*?)\" # Weekday
    .*?dt=\"(?P<date>.*?)\"> # Day number
    \s*?<hi>(?P<high>.*?)</hi> # High temperature
    \s*?<low>(?P<low>.*?)</low> # Low temperature
    .*?<icon>(?P<icon>\d*?)</icon> # Icon
    \s*?<t>(?P<sky>.*?)</t> # Sky
    .*?<ppcp>(?P<rain>\d+)</ppcp>  # Chance of rain
    '''
    datalist = [data1, data2, data3, data4]
    day = 1
    while day <= (days -1):
        forecast = weather.Forecast()
        now.add_forecast(forecast)
        match = re.search(p_forecast, datalist[day-1])
        if match:
            forecast.weekday(match.group('day')[:3])
            forecast.date(match.group('date'))
            forecast.icon(match.group('icon'))
            forecast.sky(match.group('sky'))
            forecast.temperature_high(match.group('high'), 'F')
            forecast.temperature_low(match.group('low'), 'F')
            forecast.rain(match.group('rain'));
        day += 1
        print forecast

    return now

def parseHourly(widget, data):
    import re
    import weather
    #print data
    crapstop = data.find('<hbhf>')
    data = data[crapstop:]
    
    #print data
    
    hour0 = data.find('<hour h="1"')
    hour1 = data.find('<hour h="2"')
    hour2 = data.find('<hour h="3"')
    hour3 = data.find('<hour h="4"')
    hour4 = data.find('<hour h="5"')
    hour5 = data.find('<hour h="6"')
    hour6 = data.find('<hour h="7"')
    hour7 = data.find('<hour h="8"')
    hour8 = data.find('<hour h="9"')
    hour9 = data.find('<hour h="10"')
    hour10 = data.find('<hour h="11"')
    hour11 = data.find('<hour h="12"')
    data0 = data[hour0:hour1]
    data1 = data[hour1:hour2]
    data2 = data[hour2:hour3]
    data3 = data[hour3:hour4]
    data4 = data[hour4:hour5]
    data5 = data[hour5:hour6]
    data6 = data[hour6:hour7]
    data7 = data[hour7:hour8]
    data8 = data[hour8:hour9]
    data9 = data[hour9:hour10]
    data10 = data[hour10:hour11]
    data11 = data[hour11:]
    nowhourly = weather.Observation()
    p_forecast = r'''(?isx) # No embedded flags, since they will be added later
    .*?<tmp>(?P<temp>.*?)</tmp> # Temp
    \s*<flik>(?P<heat>.*?)</flik> # Heat
    \s*<icon>(?P<icon>.*?)</icon> # Icon
    \s*<t>(?P<sky>.*?)</t> # Sky
    .*?<ppcp>(?P<rain>.*?)</ppcp>
    \s*<wind>\s*<s>(?P<speed>.*?)</s>.*<t>(?P<wind>.*?)</t>\s*</wind>
    .*?<hmid>(?P<hum>(.*?|N/A))</hmid>
    '''
    datalist = [data0, data1, data2, data3, data4, data5, data6, data7, data8, data9, data10, data11,]
    
    for i in range(12):
        #print i
        #print datalist[i]
        forecast = weather.Forecast()
        nowhourly.add_forecast(forecast)
        match = re.search(p_forecast, datalist[i])
        print match.group('sky')
        if match:
            forecast.temperature_high(match.group('temp'))
            forecast.temperature_low(match.group('heat'))
            forecast.icon(match.group('icon'))
            forecast.sky(match.group('sky'))
            forecast.rain(match.group('rain'))
            forecast.wind(match.group('wind'))
            if match.group('speed') == 'calm':
                forecast.wind_speed(0, 'mph')
            else:
                forecast.wind_speed(match.group('speed'), 'mph')
            forecast.humidity(match.group('hum'))
        #print forecast
    return nowhourly
    

def parseBBCWeatherData(data, days):
    '''Parses a page from weather.com and returns a list
    containing the current weather conditions and forecast.

    data: An unmodified html page from weather.com

    days: Number of forecast days to return (maximum 9)
    '''

    import re
    import weather

    #this maps bbc weather icons into widget icons
    iconmap = {'0':'31', '1':'32', '2':'26', '3':'28', '4':'4', '5':'22',
            '6':'21', '7':'26', '8':'26', '9':'6', '10':'9', '11':'6', '12':'6',
            '13':'12', '14':'9', '15':'12', '16':'8', '17':'8', '18':'8', '19':'15',
            '20':'15', '21':'15', '22':'14', '23':'13', '24':'14', '25':'15',
            '26':'15', '27':'15', '28':'27', '29':'17', '30':'4', '31':'2', '32':'20',
            '100':'25'}

    #'1':'31', '3':'27',
    # '32':'31', '28':'27',
    # Make sure we don't try to get any more than 5 day's forecast
    if days > 5: days = 5

    # Chop the data into more managable size
    start = data.find('<!-- global nav close -->')
    stop = data.find('</body>')
    data1 = data[start:stop]
    #print data1


    # The regular expressions needed to get the weather forecast

    # time and location of the weather report
    now = weather.Observation()

    p_city = r'forecast\slocation:\s"><h2>(?P<city>.+?),'
    match = re.search(p_city, data1)
    if match:
            match_city = match.group('city')
            print match_city
            now.place(match_city)
    #group = group.replace('&nbsp;', '')

    p_time = r'''(?ix)
    Observed</strong>:\s
    (?P<weekday>\w+)\s
    (?P<day>\d+)/(?P<month>\d+)/(?P<year>\d+)\s 
    at \s <br \s />
    (?P<time>\d+)'''
    match = re.search(p_time, data1)
    if match:
    	#print match.group('year')
	#print match.group('month')
	#print match.group('day')
	#print match.group('weekday')
	#print match.group('time')
        now.year(match.group('year'))
        now.month(match.group('month'))
        now.day(match.group('day'))
        now.weekday(match.group('weekday'))
        now.time(match.group('time'))
        now.timezone('GMT')

    #current observations
    p_current =  r'''(?isx)
    Nearest\sObservations
    .*?">(?P<sky>[^0-9/-]+)(?P<temp>[\d/-]+)
    .*?/>(?P<wind>[^\(]+)Wind \s \( (?P<speed>\d+)
    .*?</strong>:\s(?P<hum>\d+)
    .*?</strong>:\s(?P<baro>.*?),\s(?P<change>.*?),<
    .*?Visibility</strong>: \s (?P<vis>[^<]+)<
    '''
    match = re.search(p_current, data1)
    if match:
    	#print match.group('sky')
	#print match.group('temp')
	#print match.group('hum')
	#print match.group('speed')
	#print match.group('wind')
	#print match.group('baro')
	#print match.group('change')
	#print match.group('vis')
        now.sky(match.group('sky')[:-1])
        now.temperature(match.group('temp'))
        now.humidity(match.group('hum'))
        now.wind_speed(match.group('speed'),'mph')
        now.wind(match.group('wind'))
        now.pressure(match.group('baro'))
        now.pressure_change(match.group('change'))
        now.visibility(match.group('vis'))

    # day names:
    p_5day = r'''(?isx)
        day \s one   .*? <strong>(?P<today>\w{3}).*? Sunrise
    .*? day \s two   .*? <strong>(?P<day1>\w{3}) .*? Sunrise
    .*? day \s three .*? <strong>(?P<day2>\w{3}) .*? Sunrise
    .*? day \s four  .*? <strong>(?P<day3>\w{3}) .*? Sunrise
    .*? day \s five  .*? <strong>(?P<day4>\w{3}) .*? Sunrise
    '''
    match = re.search(p_5day, data1)
    print 'Finished day names'
    if match:
        today = weather.Forecast(match.group('today'))
        day1 = weather.Forecast(match.group('day1'))
        day2 = weather.Forecast(match.group('day2'))
        day3 = weather.Forecast(match.group('day3'))
	day4 = weather.Forecast(match.group('day4'))

        now.add_forecast(today)
        now.add_forecast(day1)
        now.add_forecast(day2)
        now.add_forecast(day3)
        now.add_forecast(day4)

    if len(now.forecasts) == 0:
            print "Can not parse forecasts"
            return now
    
    # sun rise:
    p_5day = r'''(?isx)
        day \s one   .*? Sunrise \s (?P<rise>[^\s\(]+)
    .*? day \s two   .*? Sunrise \s (?P<rise1>[^\s\(]+)
    .*? day \s three .*? Sunrise \s (?P<rise2>[^\s\(]+)
    .*? day \s four  .*? Sunrise \s (?P<rise3>[^\s\(]+)
    .*? day \s five  .*? Sunrise \s (?P<rise4>[^\s\(]+)
    '''
    match = re.search(p_5day, data1)
    print 'Finished sun rise'
    if (match) and (match.group('rise') != 'NA') and (match.group('rise1') != 'NA') and (match.group('rise2') != 'NA') and (match.group('rise3') != 'NA') and (match.group('rise4') != 'NA'):
    	today.sunrise(match.group('rise'))
        day1.sunrise(match.group('rise1'))
        day2.sunrise(match.group('rise2'))
        day3.sunrise(match.group('rise3'))
        day4.sunrise(match.group('rise4'))

    # sun set:
    p_5day = r'''(?isx)
        day \s one   .*? Sunset \s (?P<set>[^\s\(]+)
    .*? day \s two   .*? Sunset \s (?P<set1>[^\s\(]+)
    .*? day \s three .*? Sunset \s (?P<set2>[^\s\(]+)
    .*? day \s four  .*? Sunset \s (?P<set3>[^\s\(]+)
    .*? day \s five  .*? Sunset \s (?P<set4>[^\s\(]+)
    '''
    match = re.search(p_5day, data1)
    print 'Finished sun set'
    if (match) and (match.group('set') != 'NA') and (match.group('set1') != 'NA') and (match.group('set2') != 'NA') and (match.group('set3') != 'NA') and (match.group('set4') != 'NA'):
    	today.sunset(match.group('set'))
        day1.sunset(match.group('set1'))
        day2.sunset(match.group('set2'))
        day3.sunset(match.group('set3'))
        day4.sunset(match.group('set4'))
    
    # icons & descriptions:
    p_5day = r'''(?isx)
        day \s one   .*? /symbol_(?P<icon>\d+)  .*? summary \s is \s set \s for \s (?P<desc>[^"]+)
    .*? day \s two   .*? /symbol_(?P<icon1>\d+) .*? summary \s is \s set \s for \s (?P<desc1>[^"]+)
    .*? day \s three .*? /symbol_(?P<icon2>\d+) .*? summary \s is \s set \s for \s (?P<desc2>[^"]+)
    .*? day \s four  .*? /symbol_(?P<icon3>\d+) .*? summary \s is \s set \s for \s (?P<desc3>[^"]+)
    .*? day \s five  .*? /symbol_(?P<icon4>\d+) .*? summary \s is \s set \s for \s (?P<desc4>[^"]+)
    '''
    match = re.search(p_5day, data1)
    print 'Finished icons and descriptions'
    if match:
        today.icon(iconmap[match.group('icon')])
        today.sky(match.group('desc').replace('.',''))
        day1.icon(iconmap[match.group('icon1')])
        day1.sky(match.group('desc1').replace('.',''))
        day2.icon(iconmap[match.group('icon2')])
        day2.sky(match.group('desc2').replace('.',''))
        day3.icon(iconmap[match.group('icon3')])
        day3.sky(match.group('desc').replace('.',''))
        day4.icon(iconmap[match.group('icon4')])
        day4.sky(match.group('desc4').replace('.',''))
	now.icon(iconmap[match.group('icon')]) # Temporary solution - take the icon from the "TODAY" forcast

    # maximum and minimum temps:
    p_5day = r'''(?isx)
        day \s one   .*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? <strong>(?P<min>[\d/-]+) <abbr \s title="Night
    .*? day \s two   .*? <strong>(?P<max1>[\d/-]+)<abbr \s title="Day .*? <strong>(?P<min1>[\d/-]+)<abbr \s title="Night
    .*? day \s three .*? <strong>(?P<max2>[\d/-]+)<abbr \s title="Day .*? <strong>(?P<min2>[\d/-]+)<abbr \s title="Night
    .*? day \s four  .*? <strong>(?P<max3>[\d/-]+)<abbr \s title="Day .*? <strong>(?P<min3>[\d/-]+)<abbr \s title="Night
    .*? day \s five  .*? <strong>(?P<max4>[\d/-]+)<abbr \s title="Day .*? <strong>(?P<min4>[\d/-]+)<abbr \s title="Night
    '''
    match = re.search(p_5day, data1)
    print 'Finished maximum and minimum temps'
    if match:
    	today.temperature_high(match.group('max'))
        today.temperature_low(match.group('min'))
        day1.temperature_high(match.group('max1'))
        day1.temperature_low(match.group('min1'))
        day2.temperature_high(match.group('max2'))
        day2.temperature_low(match.group('min2'))
        day3.temperature_high(match.group('max3'))
        day3.temperature_low(match.group('min3'))
        day4.temperature_high(match.group('max4'))
        day4.temperature_low(match.group('min4'))

    # wind & speed:
    p_5day = r'''(?isx)
        day \s one   .*? /wind/(?P<wind>\w+)  .*? "Miles \s per \s hour">(?P<speed>\d+)
    .*? day \s two   .*? /wind/(?P<wind1>\w+) .*? "Miles \s per \s hour">(?P<speed1>\d+)
    .*? day \s three .*? /wind/(?P<wind2>\w+) .*? "Miles \s per \s hour">(?P<speed2>\d+)
    .*? day \s four  .*? /wind/(?P<wind3>\w+) .*? "Miles \s per \s hour">(?P<speed3>\d+)
    .*? day \s five  .*? /wind/(?P<wind4>\w+) .*? "Miles \s per \s hour">(?P<speed4>\d+)
    '''
    match = re.search(p_5day, data1)
    print 'Finished wind and speed'
    if match:
    	today.wind_speed(match.group('speed'), 'mph')
        today.wind(match.group('wind'))
        day1.wind_speed(match.group('speed1'), 'mph')
        day1.wind(match.group('wind1'))
        day2.wind_speed(match.group('speed2'), 'mph')
        day2.wind(match.group('wind2'))
        day3.wind_speed(match.group('speed3'), 'mph')
        day3.wind(match.group('wind3'))
        day4.wind_speed(match.group('speed4'), 'mph')
        day4.wind(match.group('wind4'))
    
    # visibility, pressure & humidity:
    p_5day = r'''(?isx)
        day \s one   .*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
    .*? day \s two   .*? "Visibility">(?P<visib1>[^<]+)< .*? Millibars">(?P<pressu1>\d+)< .*? percent">(?P<humidi1>\d+)<
    .*? day \s three .*? "Visibility">(?P<visib2>[^<]+)< .*? Millibars">(?P<pressu2>\d+)< .*? percent">(?P<humidi2>\d+)<
    .*? day \s four  .*? "Visibility">(?P<visib3>[^<]+)< .*? Millibars">(?P<pressu3>\d+)< .*? percent">(?P<humidi3>\d+)<
    .*? day \s five  .*? "Visibility">(?P<visib4>[^<]+)< .*? Millibars">(?P<pressu4>\d+)< .*? percent">(?P<humidi4>\d+)<
    '''
    match = re.search(p_5day, data1)
    print 'Finished visibility, pressure and humidity'
    if match:
    	today.visibility(match.group('visib'))
        day1.visibility(match.group('visib1'))
        day2.visibility(match.group('visib2'))
        day3.visibility(match.group('visib3'))
        day4.visibility(match.group('visib4'))
	today.pressure(match.group('pressu'))
        day1.pressure(match.group('pressu1'))
        day2.pressure(match.group('pressu2'))
        day3.pressure(match.group('pressu3'))
        day4.pressure(match.group('pressu4'))
	today.humidity(match.group('humidi'))
        day1.humidity(match.group('humidi1'))
        day2.humidity(match.group('humidi2'))
        day3.humidity(match.group('humidi3'))
        day4.humidity(match.group('humidi4'))
    
    ########## POLLUTION SHOULD BE ADDED:!!! ##############
    #p_5pollut = r'''(?isx)
    #Air\sPollution\sIndex
    #.*?images/5day/air_(?P<pol>\d+)
    #.*?images/5day/air_(?P<pol1>\d+)
    #.*?images/5day/air_(?P<pol2>\d+)
    #.*?images/5day/air_(?P<pol3>\d+)
    #.*?images/5day/air_(?P<pol4>\d+)
    #'''

    #match = re.search(p_5pollut, data1)
    #if match:
    #    today.pollution (match.group('pol'))
    #    day1.pollution (match.group('pol1'))
    #    day2.pollution (match.group('pol2'))
    #    day3.pollution (match.group('pol3'))
    #    day4.pollution (match.group('pol4'))

    ########## SUN INDEX SHOULD BE ADDED:!!!! #############
    #p_5sun = r'''(?isx)
    #Sun\sIndex
    #.*?images/5day/sun_(?P<sun>\d+) # sun today
    #.*?images/5day/sun_(?P<sun1>\d+)
    #.*?images/5day/sun_(?P<sun2>\d+)
    #.*?images/5day/sun_(?P<sun3>\d+)
    #.*?images/5day/sun_(?P<sun4>\d+)
    #'''
    #match = re.search(p_5sun, data1)
    #if match:
    #    today.uv( match.group('sun'))
    #    day1.uv( match.group('sun1'))
    #    day2.uv( match.group('sun2'))
    #    day3.uv( match.group('sun3'))
    #    day4.uv( match.group('sun4'))

    print now
    print 'fore------------------------------'
    print today
    print day1
    print day2
    print day3
    print day4
    print '------------------------------fore'
    
    return now

def getWeather(widget):
    #setup data structures
    global weather, hourly, url, installed, metric_units, days, windy
    print "Current URL = " + url
    if installed[0] == '~':
        home = expanduser('~')
        installed = home + installed[1:]
    filename = installed + '/karamba_weather.html'
    filenamehourly = installed + '/karamba_hourly.html'
    try:
        data = urllib2.urlopen(url).read()
        if use_wcom == 1:
            hourlyurl = 'http://xoap.weather.com/weather/local/' + wcomcode + '?cc=*&dayf=1&unit=m&hbhf=12'
            datahourly = urllib2.urlopen(hourlyurl).read()
        print data
        if data.find('BBC Weather') > 0:
            print "parsing BBC"
            weather = parseBBCWeatherData(data, days)
        else:
            print "parsing XML"
            weather = parseWeatherData(data, days)
            hourly = parseHourly(widget, datahourly)
        save = open(filename, 'w')
        print >> save, data
        save.close()
        print use_wcom
        if use_wcom == 1:
            savehourly = open(filenamehourly, 'w')
            print >> savehourly, datahourly
            savehourly.close()

    except: # Maybe we're offline?
        try: # Try to load the saved weather data
            data =  open(installed + '/karamba_weather.html', 'r').read()
            if use_wcom == 1:
                datahourly = open(installed + '/karamba_hourly.html', 'r').read()
            if data.find('<title>BBC') > 0:
                weather = parseBBCWeatherData(data,  days)
            else:
                weather = parseWeatherData(data, days)
                hourly = parseHourly(widget, datahourly)
        except:
            print "Fatal Error; Cannot connect to site or load old data"

    if use_wcom == 1:
        hourly.metric(metric_units)
        hourly.reverse_wind_arrows(windy)
    weather.metric(metric_units)
    weather.reverse_wind_arrows(windy)

def getWebcamPic(widget):
    global filenames, nowebcams
    errorpath = "file:///" + path + "webcam_failed.png"
    filenames = []
    nowebcams = int(nowebcams)
    for i in range(nowebcams):
        try:
            picture = urllib2.urlopen(webcamurls[i]).read()
        except:
            picture = urllib.urlopen(errorpath).read()
        filename = installed + '/webcampic_' + str(i) + '.jpg'
        save = open(filename, 'w')
        print >> save, picture
        save.close()
        filenames.append(filename)


def searchCodes(widget, searchurl):
    global searchsite, codespid, wcomcodespid, bbccodespid, url, configchange, werethreading
    import re
    if searchsite == 0:
        data = urllib2.urlopen(searchurl).read()
        #print data
        start = data.find('<search')
        data = data[start:]
        p = re.compile('</search>')
        match = re.search(p, data)
        #print "match: " + str(match)
        if match:
            #print "no list"
            p = re.compile('</loc>')
            codes = p.findall(data)
            #print codes
            foundcity = city.replace('+',' ')
            if len(codes) == 1:
                p = re.compile('\D{4}\d{4}')
                codes = p.findall(data)
                foundcommand = ["kdialog", "--title", '%s' %(transdial_dict.get('Location Selector')), "--msgbox", '%s' %(transdial_dict.get('City found'))]
                foundpid = karamba.executeInteractive(widget, foundcommand)
                url = url_base_addr + codes[0] + url_suffix
                karamba.writeConfigEntry(widget, "url", url)
                configchange = 1
                werethreading = 1
                widgetUpdated(widget)
            elif len(codes) > 1:
                p = re.compile('\D{4}\d{4}')
                q = re.compile('%s\D*</loc>' %(city), re.IGNORECASE | re.MULTILINE)
                codes = p.findall(data)
                cities = q.findall(data)
                print codes
                print cities
                for i in range(len(cities)):
                    cities[i] = cities[i].replace('</loc>', '')
                schcommand = ["kdialog", "--title", transdial_dict.get('Location Selector'), "--radiolist", transdial_dict.get('Please select your location from the list:')]
                for i in range(len(codes)):
                    schcommand.append(codes[i])
                    schcommand.append(cities[i])
                    schcommand.append("off")
                wcomcodespid = karamba.executeInteractive(widget, schcommand)
        else:
            foundcommand = ["kdialog", "--title", '%s' %(transdial_dict.get('Location Selector')), "--msgbox", '%s' %(transdial_dict.get('City not found'))]
            foundpid = karamba.executeInteractive(widget, foundcommand)
    if searchsite == 1:
        data = urllib2.urlopen(searchurl).read()
        p = re.compile('<b>0</b>')
        match = p.findall(data)
        if len(match) == 0:
            start = data.find('cities:')
            stop = data.find('see:')
            data1 = data[start:stop]

            p = re.compile('\d{4}&links')
            codes = p.findall(data1)
            p = re.compile('%s\D*</b>' %(city), re.IGNORECASE | re.MULTILINE)
            cities = p.findall(data1)

            for i in range(len(cities)):
                cities[i] = cities[i].replace('</b>','')
            for i in range(len(codes)):
                codes[i] = codes[i].replace('&links','')

            schcommand = ["kdialog", "--title", transdial_dict.get('Location Selector'), "--radiolist", transdial_dict.get('Please select your location from the list:')]

            for i in range(len(codes)):
                schcommand.append(codes[i])
                schcommand.append(cities[i])
                schcommand.append("off")

            bbccodespid = karamba.executeInteractive(widget, schcommand)

        else:
            foundcommand = ["kdialog", "--title", "%s" %(transdial_dict.get('Location Selector')), "--msgbox", "%s" %(transdial_dict.get('City not found'))]
            foundpid = karamba.executeInteractive(widget, foundcommand)

def getSatPic(widget, incontinent, imap):
    global satfile
    satpicurl = prefix + countries[incontinent] + map_matrix[incontinent][imap] + '.gif'
    errorpath = "file:///" + path + "webcam_failed.png"
    try:
        picture = urllib2.urlopen(satpicurl).read()
    except:
        picture = urllib.urlopen(errorpath).read()
    satfile = installed + '/satpic.jpg'
    save = open(satfile, 'w')
    print >> save, picture
    save.close()

##~ def getContinentPics(widget):
##~     global sumfile, pressfile, werethreading, continentdone
##~     errorpath = "file:///" + path + "webcam_failed.png"
##~     try:
##~         sumpic = urlopen(contmapsum[int(continent)]).read()
##~     except:
##~         sumpic = urlopen(errorpath).read()
##~     try:
##~         presspic = urlopen(contmappress[int(continent)]).read()
##~     except:
##~         presspic = urlopen(errorpath).read()
##~     sumfile = installed + '/summap.jpg'
##~     save = open(sumfile, 'w')
##~     print >> save, sumpic
##~     pressfile = installed + '/pressmap.jpg'
##~     save = open(pressfile, 'w')
##~     print >> save, presspic
##~     werethreading = 0
##~     if firsttime == 1:
##~         threadsfinished = 0
##~         while threadsfinished < 3:
##~             threadsfinished = weatherthread.isDone() + webcamthread.isDone() + satpicthread.isDone()
##~             time.sleep(1)
##~         continentdone = 1
##~         karamba.redrawWidget(widget)
##~         widgetUpdated(widget)

def createMapMenu(widget, cont_num):
    global webcammenu, satbuttmenu, mapmenu, selection
    print cont_num
    karamba.deleteMenu(widget, satbuttmenu)
    karamba.deleteMenu(widget, webcammenu)
    karamba.deleteMenu(widget, mapmenu)
    webcammenu = 0
    satbuttmenu = 0
    mapmenu = karamba.createMenu(widget)
    selection = []
    print "map_matrix length =" + str(len(map_matrix[cont_num]))
    for i in range(len(map_matrix[cont_num])):
        print i
        item = karamba.addMenuItem(widget, mapmenu, mapitemsconvert[cont_num][i], "")
        #sorts out the id of the item clicked so it's useful
        #id seems to be negative value, convert to positive
        if item < 0:
            item = item * -1
        selection.append(item)
    print selection
    karamba.popupMenu(widget, mapmenu, 30, 56)

def transError(widget, sky):
    errordiagcommand = ['kdialog', '--title', sky, '--error', '%s' %(transdial_dict.get('There is no translation for the sky conditions for your language.  Please email the developer at dmbkiwi@yahoo.com with the language and a translation.'))]
    errorpid = karamba.executeInteractive(widget, errordiagcommand)
#     print sky + '|'
#     file = open("trans_error.log","r")
#     lines = file.readlines()
#     skytest = '</eng>' + sky + '\\n'
#     test = 0
#     for i in lines:
#         print lines
#         print skytest
#         if i == skytest:
#             test = test + 1
#     if test == 0:
#         lines.append("</eng>" + sky + "\n" + "</trans>" + sky + "\n")
#     file.close()
#     file = open("trans_error.log","w")
#     file.writelines(lines)
#     file.close()

#this is called when you widget is initialized
def initWidget(widget):
    global mapmenu, weather, daytemps, daytext, daypic, daytempsrem, daytextrem, daypicrem, maintemp, pnum, hnum, rnum, situation, wind_speed, mainpic, windpic, ddon, hon, hon2, dayshow, ddcon, firsthour, buttonpressed, mainpicclick,  firsttime, background, metric_units, clock, url, mainback, clicky, daypicpos, animate, windpic_bg, windspeed, windy, webpicon, webcammenu, webcamurls, webcamlabels, nowebcams, webcamsfree, path, use_wcom, wcomcode, satpicurl, cambutt, satbutt, iconset, iconsetpath, satbuttmenu, citytext, range_font, font_range, dnamobst, p, h, r, colour, altback, threadflag, delay, kxdocker, flatflag, flatstring, kxdocker_running, kxdocker_lasttime, kxdocker, otherdetail, language, countries, map_matrix, continentitems, mapitems, continentitemsconvert, mapitemsconvert, red, green, blue, colourflag, mainwtext, reddrop, greendrop, bluedrop, shadow

    webcammenu = 0
    satbuttmenu = 0
    mapmenu = 0
    optchecked = mainback
    urltest = karamba.readConfigEntry(widget, "url")
    print urltest
    if (urltest != None):
        import re
        url = urltest
        p = re.compile('[A-Z]{4}\d{4}')
        code = p.findall(url)
        if len(code) == 0:
            p = re.compile('[0-9]{5}')
            code = p.findall(url)
            use_wcom = 0
        if len(code) > 0:
            use_wcom = 1
            wcomcode = code[0]
            satpicurl = "http://www.w3.weather.com/outlook/travel/map/" + wcomcode
    bkgdtest = karamba.readConfigEntry(widget, "bkgd")
    if (bkgdtest != None):
        mainback = bkgdtest
        if bkgdtest == 'bg9.png':
            altback = 1
        elif bkgdtest == 'bg17.png':
            altback = 2
    translationtest = karamba.readConfigEntry(widget, "language")
    if (translationtest != None):
        language = translationtest
    colourtest = karamba.readConfigEntry(widget, "textcolour")
    if (colourtest != None):
        import re
        formattest = r'''(?ix)
        r=(?P<red>\d+)\sg=(?P<green>\d+)\sb=(?P<blue>\d+)
        '''
        match = re.search(formattest, colourtest)
        red = int(match.group('red'))
        green = int(match.group('green'))
        blue = int(match.group('blue'))
        colourflag = 1
    colortest = karamba.readConfigEntry(widget, "dropcolor")
    if (colortest != None):
        import re
        formattest = r'''(?ix)
        r=(?P<red>\d+)\sg=(?P<green>\d+)\sb=(?P<blue>\d+)
        '''
        match = re.search(formattest, colortest)
        reddrop = int(match.group('red'))
        greendrop = int(match.group('green'))
        bluedrop = int(match.group('blue'))
    webcamlabels = []
    webcamurls = []
    webcamsfree = []
    for i in range(5):
        getlabel = karamba.readConfigEntry(widget, "webcamlabel_" + str(i))
        geturl = karamba.readConfigEntry(widget, "webcamurl_" + str(i))
        if (getlabel != None) and (getlabel != ''):
            webcamlabels.append(getlabel)
        if (geturl != None) and (geturl != ''):
            webcamurls.append(geturl)
        else:
            webcamsfree.append(i)
    nowebcams = len(webcamlabels)
    if nowebcams == 0:
        nowebcams = 1
    iconsettest = karamba.readConfigEntry(widget, "iconset")
    if (iconsettest != None):
        iconset = iconsettest
        if iconset == 'flat':
            flatflag = 1
            flatstring = 'flat'
        iconsetpath = 'icons/' + iconsettest + '/'
    delaytest = karamba.readConfigEntry(widget, "delay")
    if (delaytest != None):
        delay = delaytest
    #print "mainback = " + mainback
    getTranslation(widget)
    karamba.addMenuConfigOption(widget, "changeloc", transmenu_dict.get('Enter your locations code'))
    karamba.addMenuConfigOption(widget, "findwcom", transmenu_dict.get('Find location on weather.com'))
    karamba.addMenuConfigOption(widget, "findbbc", transmenu_dict.get('Find location on BBC'))
    karamba.addMenuConfigOption(widget, "addwebcamurl", transmenu_dict.get('Add webcam URL'))
    karamba.addMenuConfigOption(widget, "remwebcamurl", transmenu_dict.get('Remove webcam URL'))
    karamba.addMenuConfigOption(widget, "background", transmenu_dict.get('Change the background'))
    karamba.addMenuConfigOption(widget, "iconset", transmenu_dict.get('Change the iconset'))
    karamba.addMenuConfigOption(widget, "usemetric", transmenu_dict.get('Use metric units'))
    karamba.addMenuConfigOption(widget, "useclock", transmenu_dict.get('Use a 24 hour clock'))
    karamba.addMenuConfigOption(widget, "delay", transmenu_dict.get('Set update time delay'))
    karamba.addMenuConfigOption(widget, "animation", transmenu_dict.get('Disable icon animation'))
    karamba.addMenuConfigOption(widget, "windoption", transmenu_dict.get('Wind arrows show where wind blows to'))
    karamba.addMenuConfigOption(widget, "range_font", transmenu_dict.get('Use narrower font in forecast temp ranges'))
    karamba.addMenuConfigOption(widget, "threadflag", transmenu_dict.get('Disable threading'))
    karamba.addMenuConfigOption(widget, "dnamobst", transmenu_dict.get('Enable alternative city display'))
    karamba.addMenuConfigOption(widget, "kxdocker", transmenu_dict.get('Enable kxdocker icons'))
    karamba.addMenuConfigOption(widget, "translation", transmenu_dict.get('Choose translation'))
    karamba.addMenuConfigOption(widget, "colour", transmenu_dict.get('Change text colour on main widget'))
    karamba.addMenuConfigOption(widget, "color", transmenu_dict.get('Change text colour on drop panels'))
    karamba.addMenuConfigOption(widget, "shadow", transmenu_dict.get('Enable font shadows'))
    karamba.addMenuConfigOption(widget, "readme", transmenu_dict.get('View readme/faq'))
    threadtest = karamba.readConfigEntry(widget, "threadflag")
    if (threadtest == None):
        threadflag = 1
    else:
        threadflag = karamba.readMenuConfigOption(widget, "threadflag")
    print "threadflag: " + str(threadflag)
    metric_units = karamba.readMenuConfigOption(widget, "usemetric")
    clock = karamba.readMenuConfigOption(widget, "useclock")
    animate = karamba.readMenuConfigOption(widget, "animation")
    windy = karamba.readMenuConfigOption(widget, "windoption")
    range_font = karamba.readMenuConfigOption(widget, "range_font")
    if range_font == 1:
        font_range = "aria narrow"
    else:
        font_range = "verdana"
    shad = karamba.readMenuConfigOption(widget, "shadow")
    if shad != None:
        shadow = karamba.readMenuConfigOption(widget, "shadow")
    kxdock = karamba.readMenuConfigOption(widget, "range_font")
    if kxdock != None:
        kxdocker = karamba.readMenuConfigOption(widget, "kxdocker")
    dnamobst = karamba.readMenuConfigOption(widget, "dnamobst")
    #iconset = karamba.readMenuConfigOption(widget, "iconset")
    karamba.setMenuConfigOption(widget, "changeloc", 0)
    karamba.setMenuConfigOption(widget, "background", 0)
    karamba.setMenuConfigOption(widget, "readme", 0)
    karamba.setMenuConfigOption(widget, "findwcom", 0)
    karamba.setMenuConfigOption(widget, "findbbc", 0)
    karamba.setMenuConfigOption(widget, "addwebcamurl", 0)
    karamba.setMenuConfigOption(widget, "remwebcamurl", 0)
    karamba.setMenuConfigOption(widget, "iconset", 0)
    karamba.setMenuConfigOption(widget, "delay", 0)
    karamba.setMenuConfigOption(widget, "translation", 0)
    karamba.setMenuConfigOption(widget, "colour", 0)
    karamba.setMenuConfigOption(widget, "color", 0)
    firsttime = 0
    buttonpressed = 0
    ddcon = 0
    dayshow = 5
    ddon = 0
    hon = 0
    hon2 = 0
    otherdetail = 1
#     firsthour = 0
    webpicon = 0
    path = karamba.getThemePath(widget)
    path = path + "/"
    os.chdir(path)
    testkxd = os.popen('dcop kxdocker').readlines()
    if len(testkxd) > 1:
        kxdocker_running = 1
    
    
    #iconsetpath = "liquid/"
    #if iconset == 1:
        #iconsetpath = "um/"
    #os.system("pwd")

    #karamba.redrawWidgetBackground(widget)
    splash = karamba.createImage(widget, 10, 10, "splash.png")
    karamba.redrawWidget(widget)
    karamba.redrawWidget(widget)
    countries = ["2xus_", "2xcn_", "2xca_", "2xsa_", "2xeu_", "2xas_", "2xa2_", "2xaf_", "2xau_", "2xan_"]
    map_matrix = [['st', 'hi', 'wc', 'rh', 'rd', 'dp', 'ws', 'vs', 'vi', 'ir', 'sf', 'snow', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'vi', 'ir', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'vi', 'ir', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'vi', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt']]
    #Conversion may be required, as menus crash if you do conversion on the fly
    continentitemsconvert = [transcont_dict.get('United States'), transcont_dict.get('Canada'), transcont_dict.get('Central America'), transcont_dict.get('South America'), transcont_dict.get('Europe'), transcont_dict.get('Northern Asia'), transcont_dict.get('Southern Asia'), transcont_dict.get('Africa'), transcont_dict.get('Australia'), transcont_dict.get('Antarctica')]
    continentitems = continentitemsconvert
    mapitemsconvert = [[transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Radar'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Visible Satellite'), transmap_dict.get('Satellite'), transmap_dict.get('Fronts'), transmap_dict.get('Snow Depth'), transmap_dict.get('Jetstream')], [transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Visible Satellite'), transmap_dict.get('Satellite'), transmap_dict.get('Jetstream')], [transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Visible Satellite'), transmap_dict.get('Satellite'), transmap_dict.get('Jetstream')], [transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Jetstream')], [transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Visible Satellite'), transmap_dict.get('Jetstream')], [transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Jetstream')], [transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Jetstream')], [transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Jetstream')], [transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Jetstream')], [transmap_dict.get('Temperature'), transmap_dict.get('Heat Index'), transmap_dict.get('Wind Chill'), transmap_dict.get('Relative Humidity'), transmap_dict.get('Dew Point'), transmap_dict.get('Wind Speed'), transmap_dict.get('Visibility'), transmap_dict.get('Jetstream')]]
    mapitems = mapitemsconvert
    

    getWeather(widget)
    getWebcamPic(widget)
    karamba.deleteImage(widget, splash)
    karamba.redrawWidget(widget)
    background = karamba.createBackgroundImage(widget, 15, 15, 'background/' + mainback)
    if flatflag == 1:
        windpic_bg = karamba.createBackgroundImage(widget, 180, 62, 'wind_icons/flat/wind_bg.png')
    else:
        windpic_bg = karamba.createBackgroundImage(widget, 192, 70, 'wind_icons/liquid/wind_bg.png')
    #layout text
    p = karamba.createText(widget, 120, 58, 15, 12, "P:")
    prettyText(widget, 10, "verdana", shadow, p)
    tooltipp = karamba.createImage(widget, 120, 58, "tooltip.png")
    karamba.addImageTooltip(widget, tooltipp, transtool_dict.get('Air Pressure'))
    h = karamba.createText(widget, 120, 70, 15, 12, "H:")
    prettyText(widget, 10, "verdana", shadow, h)
    tooltiph = karamba.createImage(widget, 120, 70, "tooltip.png")
    karamba.addImageTooltip(widget, tooltiph, transtool_dict.get('Humidity'))
    r = karamba.createText(widget, 120, 82, 15, 12, "R:")
    prettyText(widget, 10, "verdana", shadow, r)
    tooltipr = karamba.createImage(widget, 120, 82, "tooltip.png")
    karamba.addImageTooltip(widget, tooltipr, transtool_dict.get('Relative Temp After Windchill'))
    maintemp = karamba.createText(widget, 120, 33, 90, 30, weather.temperature())
    prettyText(widget, 20, "arial black", shadow, maintemp)
    situtext = transsky_dict.get(weather.sky())
    if situtext == None:
        situtext = weather.sky()
        transError(widget, weather.sky())
    situation = karamba.createText(widget, 37, 104, 200, 18, situtext)
    prettyText(widget, 12, "verdana", shadow, situation)

    mainpic = karamba.createImage(widget, 0, 0, iconsetpath + weather.icon_path())
    karamba.attachClickArea(widget, mainpic)
    karamba.addImageTooltip(widget, mainpic, transtool_dict.get('Displaying weather for:') + ' ' + weather.place())

    satbutt = karamba.createImage(widget, 179, 36, 'satbutton' + flatstring + '.png')
    karamba.attachClickArea(widget, satbutt)
    cambutt = karamba.createImage(widget, 203, 36, 'webcambutton' + flatstring + '.png')
    karamba.attachClickArea(widget, cambutt)
    pnum = karamba.createText(widget, 135, 58, 75, 12, weather.pressure())
    prettyText(widget, 10, "verdana", shadow, pnum)
    hnum = karamba.createText(widget, 135, 70, 30, 12, weather.humidity())
    prettyText(widget, 10, "verdana", shadow, hnum)
    rnum = karamba.createText(widget, 135, 82, 30, 12, weather.relative_heat())
    prettyText(widget, 10, "verdana", shadow, rnum)
    windicon = weather.wind_icon_path()
    if flatflag == 1:
        windspeed = karamba.createText(widget, 190, 107, 40, 15, weather.wind_speed())
    else:
        windspeed = karamba.createText(widget, 190, 94, 40, 15, weather.wind_speed())
    prettyText(widget, 9, "verdana", shadow, windspeed)
    if flatflag == 1:
        windpic = karamba.createImage(widget, 180, 62, 'wind_icons/flat/' + windicon)
    else:
        windpic = karamba.createImage(widget, 192, 70, 'wind_icons/liquid/' + windicon)

    xstart = 37
    daytextrem = []
    daytempsrem = []
    daypicrem = []
    daypicpos = []
    base_menuime = int(weather.time()[:2])
    for i in range(0,5):
        #if i == 0:
        #    if base_menuime >= 14:
        #        sep = weather.get_forecast(i).temp_range().find('/')
        #       daytext = karamba.createText(widget, xstart, 125, 40, 12, "2nite:")
        #        daytemps = karamba.createText(widget, xstart, 168, 40, 12, "Lo:" + weather.get_forecast(i).temp_range()[:sep])
        #    else:
        #        daytext = karamba.createText(widget, xstart, 125, 40, 12, "2day:")
        #        daytemps = karamba.createText(widget, xstart, 168, 40, 12, weather.get_forecast(i).temp_range())
        #else:
        daytext = karamba.createText(widget, xstart, 125, 40, 12, transweek_dict.get(weather.get_forecast(i).weekday()) + ":")
        daytemps = karamba.createText(widget, xstart, 168, 40, 12, weather.get_forecast(i).temp_range())
        prettyText(widget, 10, "verdana", shadow, daytext)
        daytextrem.append(daytext)

        prettyText(widget, 10, font_range, shadow, daytemps)
        daytempsrem.append(daytemps)
        daypic = karamba.createImage(widget, (xstart + 5), 140, iconsetpath + weather.get_forecast(i).icon_path())
        karamba.attachClickArea(widget, daypic)
        daypicrem.append(daypic)
        daypicpos.append(xstart + 5)
        xstart = xstart + 39
    print "are we there yet?"
    mainwtext = [p, h, r, maintemp, situation, pnum, hnum, rnum, daytextrem[0], daytextrem[1], daytextrem[2], daytextrem[3], daytextrem[4], daytempsrem[0], daytempsrem[1], daytempsrem[2], daytempsrem[3],daytempsrem[4], windspeed]
    karamba.redrawWidget(widget)
    if (kxdocker_running == 1) and (kxdocker == 1):
        sep = weather.get_forecast(i).temp_range().find('/')
	icopath = path + iconsetpath + weather.icon_path()        
        day1txt = 'Today:'
        day1tmp = weather.get_forecast(0).temp_range()
        if base_menuime >= 14:
            day1txt = 'Tonight:'
            day1tmp = "Lo:" + weather.get_forecast(0).temp_range()[:sep]
        print icopath
        os.system('dcop kxdocker docker addIcon Current %s "%s : %s" /dev/null GIcon lwp none none none none' %(icopath, situtext, weather.temperature()))
        os.system('dcop kxdocker docker addIcon For1 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(0).icon_path().replace('small_icons', 'large_icons'), day1txt, day1tmp))
        os.system('dcop kxdocker docker addIcon For2 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(1).icon_path().replace('small_icons', 'large_icons'), transweek_dict.get(weather.get_forecast(1).weekday()) + ":", weather.get_forecast(1).temp_range()))
        os.system('dcop kxdocker docker addIcon For3 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(2).icon_path().replace('small_icons', 'large_icons'), transweek_dict.get(weather.get_forecast(2).weekday()) + ":", weather.get_forecast(2).temp_range()))
        os.system('dcop kxdocker docker addIcon For4 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(3).icon_path().replace('small_icons', 'large_icons'), transweek_dict.get(weather.get_forecast(3).weekday()) + ":", weather.get_forecast(3).temp_range()))
        os.system('dcop kxdocker docker addIcon For5 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(4).icon_path().replace('small_icons', 'large_icons'), transweek_dict.get(weather.get_forecast(4).weekday()) + ":", weather.get_forecast(4).temp_range()))
        kxdocker_lasttime = 1
#this is called everytime your widget is updated
#the update inverval is specified in the .theme filed
def widgetUpdated(widget):
    global weather, daytempsrem, daytextrem, daypicrem, maintemp, pnum, hnum, rnum, situation, wind_speed, mainpic, daytext, daytemps, daypics, windpic, windpic_bg, buttonpressed, backgroud, timegate, configchange, firsttime, clicky, daypicpos, windspeed, werethreading, satbutt, cambutt, windpic_bg, flatflag, windspeed, kxdocker_running, kxdocker_lasttime, kxdocker
    #karamba.createBackgroundImage(widget, 15, 15, "bg1.png")
    #karamba.redrawWidget(widget)
    #background = karamba.createBackgroundImage(widget, 15, 15, "bg1.png")
    #iconsetpath = "liquid/"
    #if iconset == 1:
        #iconsetpath = "um/"
    if buttonpressed == 0:
        if firsttime == 0:
            karamba.redrawWidgetBackground(widget)
            werethreading = 1
        #double check.  don't depend on INTERVAL
        #widgetUpdated can happen for other reasons
        #print (time.time() - timegate)
        if ((time.time() - timegate) > delaylist[delay]) or (configchange == 1):
            if threadflag == 0:
                if werethreading == 1:
                    getThreadedData(widget)
            else:
                if flatflag == 1:
                    loadbar = karamba.createImage(widget, 36, 105, 'nothing' + flatstring + '.png')
                else:
                    loadbar = karamba.createImage(widget, 120, 94, 'nothing' + flatstring + '.png')
                karamba.redrawWidget(widget)
                getWeather(widget)
                karamba.deleteImage(widget, loadbar)
                if flatflag == 1:
                    loadbar = karamba.createImage(widget, 36, 105, 'half' + flatstring + '.png')
                else:
                    loadbar = karamba.createImage(widget, 120, 94, 'half' + flatstring + '.png')
                karamba.redrawWidget(widget)
                getWebcamPic(widget)
                karamba.deleteImage(widget, loadbar)
                if flatflag == 1:
                    loadbar = karamba.createImage(widget, 36, 105, 'done' + flatstring + '.png')
                else:
                    loadbar = karamba.createImage(widget, 120, 94, 'done' + flatstring + '.png')
                karamba.redrawWidget(widget)
                time.sleep(1)
                karamba.deleteImage(widget, loadbar)
                karamba.redrawWidget(widget)
            getTranslation(widget)
            #print "Updating, button not pressed"
            #loadingtext = karamba.createText(widget, 120, 90, 200, 18, "Loading...")
            #prettyText(widget, 10, "verdana", shadow, loadingtext)
            #karamba.redrawWidget(widget)
            #karamba.redrawWidget(widget)
            #getWeather(widget)
            #print "Update weather..."
            #getWebcamPic(widget)
            #print "Update webcams..."
            #getContinentPics(widget)
            #print "Update continents..."
            #if use_wcom == 1:
                #getSatPic(widget)
                #print "Update satellite..."
            #karamba.deleteText(widget, loadingtext)
            #karamba.redrawWidget(widget)
            timegate = time.time()
            configchange = 0
        print '>>>>>>>>>>>>>>>>>>>>> widgetUpdated <<<<<<<<<<<<<<<<<<<<<<<<'
        karamba.changeText(widget, maintemp, weather.temperature())
        prettyText(widget, 20, "arial black", shadow, maintemp)
        situtext = transsky_dict.get(weather.sky())
        if situtext == None:
            situtext = weather.sky()
            transError(widget, weather.sky())
        karamba.changeText(widget, situation, situtext)
        prettyText(widget, 12, "verdana", shadow, situation)
        karamba.deleteText(widget, windspeed)
        karamba.redrawWidget(widget)
        if flatflag == 1:
            windspeed = karamba.createText(widget, 190, 107, 40, 15, weather.wind_speed())
        else:
            windspeed = karamba.createText(widget, 190, 94, 40, 15, weather.wind_speed())
        prettyText(widget, 9, "verdana", shadow, windspeed)
        karamba.deleteImage(widget, mainpic)
        karamba.deleteImage(widget, satbutt)
        karamba.deleteImage(widget, cambutt)
        karamba.deleteImage(widget, windpic_bg)
        #karamba.deleteImage(widget, windpic_bg)
        #print today[6]
        satbutt = karamba.createImage(widget, 179, 36, 'satbutton' + flatstring + '.png')
        karamba.attachClickArea(widget, satbutt)
        cambutt = karamba.createImage(widget, 203, 36, 'webcambutton' + flatstring + '.png')
        karamba.attachClickArea(widget, cambutt)
        if flatflag == 1:
            windpic_bg = karamba.createBackgroundImage(widget, 180, 62, 'wind_icons/flat/wind_bg.png')
        else:
            windpic_bg = karamba.createBackgroundImage(widget, 192, 70, 'wind_icons/liquid/wind_bg.png')
        mainpic = karamba.createImage(widget, 0, 0, iconsetpath + weather.icon_path())
        karamba.attachClickArea(widget, mainpic)
        windicon = weather.wind_icon_path()
        karamba.deleteImage(widget, windpic)
        karamba.redrawWidget(widget)
        karamba.redrawWidgetBackground(widget)
        if flatflag == 1:
            windpic = karamba.createImage(widget, 180, 62, 'wind_icons/flat/' + windicon)
        else:
            windpic = karamba.createImage(widget, 192, 70, 'wind_icons/liquid/' + windicon)
        #windpic_bg = karamba.createImage(widget, 192, 70, "wind_icons/wind_bg.png")
        karamba.redrawWidget(widget)
        #print mainpic
        xstart = 37
        base_menuime = int(weather.time()[:2])
        for i in range(0,5):
            print 'aaaaaaaaaaaaaa===arraylen:'+ str(i)+ ':'
            if i == 0:
                if base_menuime >= 14:
                    sep = weather.get_forecast(i).temp_range().find('/')
                    karamba.changeText(widget, daytextrem[i], transweek_dict.get('2nite') + ':')
                    prettyText(widget, 10, "verdana", shadow, daytextrem[i])
                    karamba.changeText(widget, daytempsrem[i], "Lo:" + weather.get_forecast(i).temp_range()[:sep])
                    prettyText(widget, 10, font_range, shadow, daytempsrem[i])
                else:
                    karamba.changeText(widget, daytextrem[i], transweek_dict.get('2day') + ':')
                    prettyText(widget, 10, "verdana", shadow, daytextrem[i])
                    karamba.changeText(widget, daytempsrem[i], weather.get_forecast(i).temp_range())
                    prettyText(widget, 10, font_range, shadow, daytempsrem[i])
            else:
                karamba.changeText(widget, daytextrem[i], transweek_dict.get(weather.get_forecast(i).weekday()) + ":")
                prettyText(widget, 10, "verdana", shadow, daytextrem[i])
                karamba.changeText(widget, daytempsrem[i], weather.get_forecast(i).temp_range())
                prettyText(widget, 10, font_range, shadow, daytempsrem[i])
            #karamba.redrawWidget(widget)
            karamba.deleteImage(widget, daypicrem[i])
            daypic = karamba.createImage(widget, (xstart + 5), 140, iconsetpath + weather.get_forecast(i).icon_path())
            karamba.attachClickArea(widget, daypic)
            karamba.redrawWidget(widget)
            daypicrem[i] = daypic
            daypicpos[i] = (xstart + 5)
            xstart +=  39
        karamba.changeText(widget, pnum, weather.pressure())
        prettyText(widget, 10, "verdana", shadow, pnum)
        karamba.changeText(widget, hnum, weather.humidity())
        prettyText(widget, 10, "verdana", shadow, hnum)
        karamba.changeText(widget, rnum, weather.relative_heat())
        prettyText(widget, 10, "verdana", shadow, rnum)
        prettyText(widget, 10, "verdana", shadow, p)
        prettyText(widget, 10, "verdana", shadow, r)
        prettyText(widget, 10, "verdana", shadow, h)
        #karamba.changeText(widget, wind_speed, today[9])
        karamba.redrawWidget(widget)
        testkxd = os.popen('dcop kxdocker').readlines()
        if len(testkxd) > 1:
            kxdocker_running = 1
        if kxdocker_running == 1:
            if (kxdocker == 1) and (kxdocker_lasttime == 1):
                os.system('dcop kxdocker docker changeImageByName Current %s' %(path + iconsetpath + weather.icon_path()))
                os.system('dcop kxdocker docker changeImageByName For1 %s' %(path + iconsetpath + weather.get_forecast(0).icon_path()).replace('small_icons', 'large_icons'))
                os.system('dcop kxdocker docker changeImageByName For2 %s' %(path + iconsetpath + weather.get_forecast(1).icon_path()).replace('small_icons', 'large_icons'))
                os.system('dcop kxdocker docker changeImageByName For3 %s' %(path + iconsetpath + weather.get_forecast(2).icon_path()).replace('small_icons', 'large_icons'))
                os.system('dcop kxdocker docker changeImageByName For4 %s' %(path + iconsetpath + weather.get_forecast(3).icon_path()).replace('small_icons', 'large_icons'))
                os.system('dcop kxdocker docker changeImageByName For5 %s' %(path + iconsetpath + weather.get_forecast(4).icon_path()).replace('small_icons', 'large_icons'))
                day1txt = 'Today:'
                day1tmp = weather.get_forecast(0).temp_range()
                if base_menuime >= 14:
                    day1txt = 'Tonight:'
                    day1tmp = "Lo:" + weather.get_forecast(0).temp_range()[:sep]
                os.system('dcop kxdocker docker changeTextByName Current "%s : %s"' %(situtext, weather.temperature()))
                os.system('dcop kxdocker docker changeTextByName For1 "%s %s"' %(day1txt, day1tmp))
                os.system('dcop kxdocker docker changeTextByName For2 "%s %s"' %(transweek_dict.get(weather.get_forecast(1).weekday()) + ":", weather.get_forecast(1).temp_range()))
                os.system('dcop kxdocker docker changeTextByName For3 "%s %s"' %(transweek_dict.get(weather.get_forecast(2).weekday()) + ":", weather.get_forecast(2).temp_range()))
                os.system('dcop kxdocker docker changeTextByName For4 "%s %s"' %(transweek_dict.get(weather.get_forecast(3).weekday()) + ":", weather.get_forecast(3).temp_range()))
                os.system('dcop kxdocker docker changeTextByName For5 "%s %s"' %(transweek_dict.get(weather.get_forecast(4).weekday()) + ":", weather.get_forecast(4).temp_range()))
                kxdocker_lasttime = 1
            elif (kxdocker == 1) and (kxdocker_lasttime == 0):
                icopath = path + iconsetpath + weather.icon_path()        
                day1txt = 'Today:'
                day1tmp = weather.get_forecast(0).temp_range()
                if base_menuime >= 14:
                    day1txt = 'Tonight:'
                    day1tmp = "Lo:" + weather.get_forecast(0).temp_range()[:sep]
#                 print icopath
                os.system('dcop kxdocker docker addIcon Current %s "%s : %s" /dev/null GIcon lwp none none none none' %(icopath, situtext, weather.temperature()))
                os.system('dcop kxdocker docker addIcon For1 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(0).icon_path().replace('small_icons', 'large_icons'), day1txt, day1tmp))
                os.system('dcop kxdocker docker addIcon For2 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(1).icon_path().replace('small_icons', 'large_icons'), transweek_dict.get(weather.get_forecast(1).weekday()) + ":", weather.get_forecast(1).temp_range()))
                os.system('dcop kxdocker docker addIcon For3 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(2).icon_path().replace('small_icons', 'large_icons'), transweek_dict.get(weather.get_forecast(2).weekday()) + ":", weather.get_forecast(2).temp_range()))
                os.system('dcop kxdocker docker addIcon For4 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(3).icon_path().replace('small_icons', 'large_icons'), transweek_dict.get(weather.get_forecast(3).weekday()) + ":", weather.get_forecast(3).temp_range()))
                os.system('dcop kxdocker docker addIcon For5 %s "%s %s" /dev/null GIcon lwp none none none none' %(path + iconsetpath + weather.get_forecast(4).icon_path().replace('small_icons', 'large_icons'), transweek_dict.get(weather.get_forecast(4).weekday()) + ":", weather.get_forecast(4).temp_range()))
                kxdocker_lasttime = 1
    buttonpressed = 0
    firsttime = 1
    werethreading = 1

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
    global clicky, dayshow, buttonpressed, oldday
    pass
#
#   if ((x > 0) and (x < 120) and (y > 0) and (y < 120)) and (button == 1):
#       if ddcon == 0:
#           if ddon == 1:
#               deleteDayDetail(widget, dayshow)
#               karamba.redrawWidget(widget)
#           createCurrentDetail(widget)
#           karamba.redrawWidget(widget)
#       else:
#           deleteCurrentDetail(widget)



#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass

def meterClicked(widget, meter, button):
    global dayshow, daypicrem, ddon, ddcon, buttonpressed, clicky, mapmenu, selection, webcammenu, satbuttmenu, satfilenames, hon, hon2, otherdetail
    satfilenames = [installed + '/satpic.jpg', installed + '/summap.jpg', installed + '/pressmap.jpg']
    selection = []
#     print "meterclick: " + str(meter) + 'dayshow:' + str(dayshow) + ' ddon:' + str(ddon) + ' ddcon:' + str(ddcon)
    if (meter == cambutt) and (button == 2) and (webpicon == 1):
        karamba.changeImageIntensity(widget, webbypic, 0.4, 300)
        karamba.redrawWidget(widget)
        os.system('kview %s &' %(filenames[webcamdisplay]))
        removeWebcamPic(widget)
    elif (meter == satbutt) and (button == 2) and (satpicon == 1):
        karamba.changeImageIntensity(widget, satpic, 0.4, 300)
        karamba.redrawWidget(widget)
        os.system('kview %s &' %(satfile))
        removeSatPic(widget)
    elif (meter == cambutt) and (button == 1):
        if (webpicon == 0) and (satpicon == 0) and (ddcon == 0) and (ddon == 0) and (hon == 0):
            karamba.deleteMenu(widget, webcammenu)
            karamba.deleteMenu(widget, satbuttmenu)
            satbuttmenu = 0
            webcammenu = karamba.createMenu(widget)
            for i in range(len(webcamlabels)):
                item = karamba.addMenuItem(widget, webcammenu, webcamlabels[i], "")
                #sorts out the id of the item clicked so it's useful
                #id seems to be negative value, convert to positive
                if item < 0:
                    item = item * -1
                selection.append(item)
            karamba.popupMenu(widget, webcammenu, 30, 56)
        elif (webpicon == 1):
            removeWebcamPic(widget)
            karamba.redrawWidget(widget)
        else:
            pass
    elif (meter == satbutt) and (button == 1):
        if (webpicon == 0) and (satpicon == 0) and (ddcon == 0) and (ddon == 0) and (hon == 0):
            karamba.deleteMenu(widget, satbuttmenu)
            karamba.deleteMenu(widget, webcammenu)
            webcammenu = 0
            mapmenu = 0
            satbuttmenu = karamba.createMenu(widget)
            for i in range(len(continentitems)):
                item = karamba.addMenuItem(widget, satbuttmenu, continentitemsconvert[i], "")
                #sorts out the id of the item clicked so it's useful
                #id seems to be negative value, convert to positive
                if item < 0:
                    item = item * -1
                selection.append(item)
            karamba.popupMenu(widget, satbuttmenu, 30, 56)
        elif (webpicon == 1):
            removeWebcamPic(widget)
            karamba.redrawWidget(widget)
        elif (satpicon == 1):
            removeSatPic(widget)
            karamba.redrawWidget(widget)
        else:
            pass

    elif (meter == mainpic) and (button == 1):
        if ddcon == 0:
            if hon == 1:
                deleteHourlyDetail1(widget)
                karamba.redrawWidget(widget)
            elif hon2 == 1:
                deleteHourlyDetail2(widget)
                karamba.redrawWidget(widget)
            elif ddon == 1:
                if use_wcom ==0:
                    deleteBBCDayDetail(widget, dayshow)
                else:
                    deleteWcomDayDetail(widget, dayshow)
                karamba.redrawWidget(widget)
            elif webpicon == 1:
                removeWebcamPic(widget)
                karamba.redrawWidget(widget)
            elif satpicon == 1:
                removeSatPic(widget)
                karamba.redrawWidget(widget)
            createCurrentDetail(widget)
            karamba.redrawWidget(widget)
        else:
            deleteCurrentDetail(widget)
    elif (meter == mainpic) and (button == 2):
        if use_wcom == 0:
            pass
        elif hon == 0 and otherdetail == 1:
            if ddcon == 1:
                deleteCurrentDetail(widget)
                karamba.redrawWidget(widget)
            if ddon == 1:
                if use_wcom == 0:
                    deleteBBCDayDetail(widget, dayshow)
                else:
                    deleteWcomDayDetail(widget, dayshow)
                karamba.redrawWidget(widget)
            elif webpicon == 1:
                removeWebcamPic(widget)
                karamba.redrawWidget(widget)
            elif satpicon == 1:
                removeSatPic(widget)
                karamba.redrawWidget(widget)
            createHourlyDetail1(widget)
            karamba.redrawWidget(widget)
        elif hon == 1:
            deleteHourlyDetail1(widget)
        elif hon2 == 0 and otherdetail == 0:
            if ddcon == 1:
                deleteCurrentDetail(widget)
                karamba.redrawWidget(widget)
            if ddon == 1:
                if use_wcom == 0:
                    deleteBBCDayDetail(widget, dayshow)
                else:
                    deleteWcomDayDetail(widget, dayshow)
                karamba.redrawWidget(widget)
            elif webpicon == 1:
                removeWebcamPic(widget)
                karamba.redrawWidget(widget)
            elif satpicon == 1:
                removeSatPic(widget)
                karamba.redrawWidget(widget)
            createHourlyDetail2(widget)
            karamba.redrawWidget(widget)
        elif hon2 == 1:
            deleteHourlyDetail2(widget)
    #elif (meter == mainpic) and (button == 2):
        #if webpicon == 0:
            #if ddcon == 1:
                #deleteCurrentDetail(widget)
                #karamba.redrawWidget(widget)
            #elif ddon == 1:
                #deleteDayDetail(widget, dayshow)
                #karamba.redrawWidget(widget)
            #showWebcamPic(widget)
            #karamba.redrawWidget(widget)
        #else:
            #removeWebcamPic(widget)
    else:
        for i in range(0,5):
            if (meter == daypicrem[i]) and (button == 1) and (dayshow != i):
#                 print "buttonpressed: day" + str(i)
                if ddon == 1:
                    if use_wcom == 0:
                        deleteBBCDayDetail(widget, dayshow)
                    else:
                        deleteWcomDayDetail(widget, dayshow)
                    karamba.redrawWidget(widget)
                elif ddcon == 1:
                    deleteCurrentDetail(widget)
                    karamba.redrawWidget(widget)
                elif hon == 1:
                    deleteHourlyDetail1(widget)
                    karamba.redrawWidget(widget)
                elif hon2 == 1:
                    deleteHourlyDetail2(widget)
                    karamba.redrawWidget(widget)
                elif webpicon == 1:
                    removeWebcamPic(widget)
                    karamba.redrawWidget(widget)
                elif satpicon == 1:
                    removeSatPic(widget)
                    karamba.redrawWidget(widget)
                if use_wcom == 0:
                    createBBCDayDetail(widget, i)
                else:
                    createWcomDayDetail(widget, i)
                karamba.redrawWidget(widget)
                dayshow = i
                break
            if (meter == daypicrem[i]) and (button == 1) and (dayshow == i):
#                 print "deleting ... buttonpressed: day" + str(i)
                if ddon == 1:
                    if use_wcom == 0:
                        deleteBBCDayDetail(widget, dayshow)
                    else:
                        deleteWcomDayDetail(widget, dayshow)
                    karamba.redrawWidget(widget)
                elif ddon == 0:
                    if use_wcom == 0:
                        createBBCDayDetail(widget, i)
                    else:
                        createWcomDayDetail(widget, i)
                    karamba.redrawWidget(widget)
                elif ddcon == 1:
                    deleteCurrentDetail(widget)
                    karamba.redrawWidget(widget)
                elif hon == 1:
                    deleteHourlyDetail1(widget)
                    karamba.redrawWidget(widget)
                elif hon2 ==1:
                    deleteHourlyDetail2(widget)
                    karamba.redrawWidget(widget)
                elif webpicon == 1:
                    removeWebcamPic(widget)
                    karamba.redrawWidget(widget)
                elif satpicon == 1:
                    removeSatPic(widget)
                    karamba.redrawWidget(widget)
                dayshow = i
                break
    buttonpressed = 1

def menuItemClicked(widget, menu, id):
    global webcamdisplay, whichone, whichcontinent
    print id
    id = id * -1
    if menu == webcammenu:
        webcamdisplay = selection.index(id)
        showWebcamPic(widget)
    if menu == satbuttmenu:
        whichone = selection.index(id)
        print "whichone: " + str(whichone)
        createMapMenu(widget, whichone)
        whichcontinent = whichone
    if menu == mapmenu:
#         print selection
#         print index
        whichone = selection.index(id)
#         print whichone
        getSatPic(widget, whichcontinent, whichone)
        showSatPic(widget)
#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    global clock, metric_units, url, url_base_addr, configchange, mainback, background, animate, bkgdpid, locpid, wcompid, bbcpid, searchsite, wcomcodespid, bbccodespid, windy, webcamurlpid, remwebcampid, webcamlabelpid, iconset, contpid, werethreading, iconpid, range_font, font_range, threadflag, dnamobst, delaypid, kxdocker, kxdocker_lasttime, language, translationpid, colourpid, dropcolorpid, shadow
    contpid = None
    bkgdpid = None
    locpid = None
    wcompid = None
    bbcpid = None
    wcomcodespid = None
    bbccodespid = None
    webcampid = None
    remwebcampid = None
    webcamurlpid = None
    webcamlabelpid = None
    iconpid = None
    delaypid = None
    translationpid = None
    colourpid = None
    dropcolorpid = None
#     print "Config Clicked"
    iconcommand = ["kdialog", "--title", transdial_dict.get('Iconset Selector'), "--radiolist", transdial_dict.get('Please select an iconset to use:'), "liquid", transdial_dict.get('Original Liquid Icons'), "off", "um", transdial_dict.get('Umicons'), "off", "weather.com", transdial_dict.get('Weather.com Icons'), "off", "flat", transdial_dict.get('Flat Desktop Style'), "off"]
    bkgdcommand = ["kdialog", "--title", transdial_dict.get('Background Selector'), "--radiolist", transdial_dict.get('Please select a background to use:'), "bg0.png", transdial_dict.get('Stippled White Raised'), "off", "bg1.png", transdial_dict.get('Plain White Raised (1)'), "off", "bg2.png", transdial_dict.get('Plain White Flat (1)'), "off", "bg3.png", transdial_dict.get('Plain White Raised (2)'), "off", "bg4.png", transdial_dict.get('Plain White Flat (2)'), "off", "bg5.png", transdial_dict.get('Plain Gray Raised (1)'), "off", "bg6.png", transdial_dict.get('Plain Gray Flat (1)'), "off", "bg7.png", transdial_dict.get('Plain Gray Raised (2)'), "off", "bg8.png", transdial_dict.get('Plain Gray Flat (2)'), "off", "bg9.png", transdial_dict.get('Black Shiny Flat'), "off", "bg10.png", transdial_dict.get('Cynapses'), "off", "bg16.png", transdial_dict.get('Original Flat'), "off", "bg11.png", transdial_dict.get('Flat (Alternate)'), "off", "bg12.png", transdial_dict.get('Flat (Alpha 80)'), "off", "bg13.png", transdial_dict.get('Flat (Alpha 50)'), "off", "bg14.png", transdial_dict.get('Flat (Alpha 20)'), "off", "bg15.png", transdial_dict.get('Flat (Shadow)'), "off", "bg17.png", transdial_dict.get('Crystal'), "off", "bg18.png", transdial_dict.get('PostIt Note'), "off", "bg19.png", transdial_dict.get('Clear'), "off"]
    loccommand = ["kdialog", "--title", transdial_dict.get('Location Configuration'), "--inputbox", transdial_dict.get('Please enter your US Zip Code, Weather.com Location ID or BBC 4 digit Weather Code (from www.bbc.co.uk/weather):')]
    findwcomcommand = ["kdialog", "--title", transdial_dict.get('Find location on weather.com'), "--inputbox", transdial_dict.get('Enter the name of the city or town you want to search for:')]
    findbbccommand = ["kdialog", "--title", transdial_dict.get('Find location on BBC'), "--inputbox", transdial_dict.get('Enter the name of the city or town you want to search for:')]
    addwebcamurlcommand1 = ["kdialog", "--title", transdial_dict.get('Add webcam URL'), "--inputbox", transdial_dict.get('Enter a URL that points to the desired webcam:')]
    delaycommand = ["kdialog", "--title", transdial_dict.get('Set Update Delay'), "--radiolist", transdial_dict.get('Please select delay between updates:'), "0", transdial_dict.get('One hour'), "off", "1", transdial_dict.get('Two hours'), "off", "2", transdial_dict.get('Three hours'), "off"]
    translationcommand = ["kdialog", "--title", transdial_dict.get('Choose Translation'), "--radiolist", transdial_dict.get('Please select the language to use:')]
    colourcommand = ["kdialog", "--title", transdial_dict.get('Choose Text Colour'), "--inputbox", transdial_dict.get('Enter r,g,b colour in this format:  r=xxx g=xxx b=xxx')]
    colordropcommand = ["kdialog", "--title", transdial_dict.get('Choose Text Colour'), "--inputbox", transdial_dict.get('Enter r,g,b colour in this format:  r=xxx g=xxx b=xxx')]
    if (key == "colour"):
        karamba.setMenuConfigOption(widget, "colour", 0)
        colourpid = karamba.executeInteractive(widget, colourcommand)

    elif (key == "color"):
        karamba.setMenuConfigOption(widget, "color", 0)
        dropcolorpid = karamba.executeInteractive(widget, colordropcommand)
        
    elif (key == "translation"):
        karamba.setMenuConfigOption(widget, "translation", 0)
        for i in range(len(os.listdir(os.getcwd() + '/translations'))):
            translationcommand.append(str(i))
            translationcommand.append(str(os.listdir(os.getcwd() + '/translations')[i]))
            translationcommand.append("off")
        translationpid = karamba.executeInteractive(widget, translationcommand)
    
    elif (key == "delay"):
        karamba.setMenuConfigOption(widget, "delay", 0)
        delaypid = karamba.executeInteractive(widget, delaycommand)
    
    elif (key == "background"):
        karamba.setMenuConfigOption(widget, "background", 0)
        bkgdpid = karamba.executeInteractive(widget, bkgdcommand)

    elif (key == "animation"):
        animate = karamba.readMenuConfigOption(widget, "animation")

    elif (key == "usemetric"):
        metric_units = karamba.readMenuConfigOption(widget, "usemetric")
        configchange = 1
        werethreading = 1
        widgetUpdated(widget)

    elif (key == "kxdocker"):
        kxdocker = karamba.readMenuConfigOption(widget, "kxdocker")
#         print kxdocker
        if kxdocker == 0:
            try:
                index = os.popen('dcop kxdocker docker findIcon Current').read()
                os.system('dcop kxdocker docker removeIcon %s' %(index))
                kxdocker_lasttime = 0
            except:
                pass
        if kxdocker == 1:
            configchange = 1
            widgetUpdated(widget)    
            
    elif (key == "useclock"):
        clock = karamba.readMenuConfigOption(widget, "useclock")
        configchange = 1
        werethreading = 1
        widgetUpdated(widget)

    elif (key == "windoption"):
        windy = karamba.readMenuConfigOption(widget, "windoption")
        configchange = 1
        widgetUpdated(widget)
    elif (key == "shadow"):
        shadow = karamba.readMenuConfigOption(widget, "shadow")
        configchange = 0
        widgetUpdated(widget)

    elif (key == "range_font"):
        range_font = karamba.readMenuConfigOption(widget, "range_font")
        if range_font == 1:
            font_range = "arial narrow"
        else:
            font_range = "verdana"
        configchange = 0
        widgetUpdated(widget)

    elif (key == "threadflag"):
        threadflag = karamba.readMenuConfigOption(widget, "threadflag")

    elif (key == "iconset"):
        karamba.setMenuConfigOption(widget, "iconset", 0)
        iconpid = karamba.executeInteractive(widget, iconcommand)

    elif (key == "dnamobst"):
        dnamobst = karamba.readMenuConfigOption(widget, "dnamobst")
        configchange = 1
        widgetUpdated(widget)
        
    elif (key == "changeloc"):
        karamba.setMenuConfigOption(widget, "changeloc", 0)
        #pipe = os.popen("kdialog --title \"Location Configuration\" --inputbox \"Please enter your US Zip Code, Weather.com Location ID\n or BBC 4 digit Weather Code (from www.bbc.co.uk/weather):\"", 'r')
        locpid = karamba.executeInteractive(widget, loccommand)
        #rawarea = pipe.readlines()
        #zipcode = rawarea[0].strip()
        #if (zipcode != ""):
            #if len(zipcode) > 4 :
                #url = url_base_addr + zipcode
            #else :
                #url= url_bbc_base_addr + zipcode + url_bbc_add_addr
            #karamba.writeConfigEntry(widget, "url", url)
            #widgetUpdated(widget)
        #configchange = 1

    elif (key == "readme"):
        karamba.setMenuConfigOption(widget, "readme", 0)
        os.system('kfmclient openURL ./readme_faq.html &')

    elif (key == "findwcom"):
        karamba.setMenuConfigOption(widget, "findwcom", 0)
        wcompid = karamba.executeInteractive(widget, findwcomcommand)

    elif (key == "findbbc"):
        karamba.setMenuConfigOption(widget, "findbbc", 0)
        bbcpid = karamba.executeInteractive(widget, findbbccommand)

    elif (key == "addwebcamurl"):
        karamba.setMenuConfigOption(widget, "addwebcamurl", 0)
        if len(webcamsfree) == 0:
            diacommand = ['kdialog', '--title', transdial_dict.get('Too Many Webcams Loaded'), '--error', transdial_dict.get('You already have 5 webcams loaded.  You need to delete one first.')]
        else:
            webcamurlpid = karamba.executeInteractive(widget, addwebcamurlcommand1)

    elif (key == "remwebcamurl"):
        karamba.setMenuConfigOption(widget, "remwebcamurl", 0)
        remwebcamcommand = ["kdialog", "--title", transdial_dict.get('Remove A Webcam'), "--radiolist", transdial_dict.get('Choose the webcam to be removed:')]
        for i in range(nowebcams):
            remwebcamcommand.append(str(i))
            remwebcamcommand.append(webcamlabels[i])
            remwebcamcommand.append("off")
        remwebcampid = karamba.executeInteractive(widget, remwebcamcommand)

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
    global bkgdpid, locpid, wcompid, bbcpid, mainback, background, configchange, url, url_base_addr, url_bbc_base_addr, searchsite, city, url_webcam, webcamlabelpid, nowebcams, webcamlabels, webcamurls, webcamsfree, use_wcom, wcomcode, satpicurl, werethreading, iconset, iconsetpath, colour, altback, windpic_bg, delay, flatflag, flatstring, language, red, green, blue, colourflag, reddrop, greendrop, bluedrop
    
    if pid == colourpid:
        import re
        formattest = r'''(?ix)
        r=(?P<red>\d+)\sg=(?P<green>\d+)\sb=(?P<blue>\d+)
        '''
        match = re.search(formattest, output)
        if match == None:
            dialcommand = ['kdialog', '--title',  transdial_dict.get('Formatting Error'), '--error', transdial_dict.get('Please enter information in the correct format.')]
            karamba.executeInteractive(widget, dialcommand) 
        elif (int(match.group('red')) > 255) or (int(match.group('green')) > 255) or (int(match.group('blue')) > 255):
            dialcommand = ['kdialog', '--title',  transdial_dict.get('r,g,b Value Error'), '--error', transdial_dict.get('r, g, b values may not be greater than 255.')]
            karamba.executeInteractive(widget, dialcommand)
        else:
            red = int(match.group('red'))
            green = int(match.group('green'))
            blue = int(match.group('blue'))
            karamba.writeConfigEntry(widget, "textcolour", 'r=' + str(match.group('red')) + ' g=' + str(match.group('green')) + ' b=' + str(match.group('blue')))
            configchange = 0
            widgetUpdated(widget)
    elif pid == dropcolorpid:
        import re
        formattest = r'''(?ix)
        r=(?P<red>\d+)\sg=(?P<green>\d+)\sb=(?P<blue>\d+)
        '''
        match = re.search(formattest, output)
        if match == None:
            dialcommand = ['kdialog', '--title',  transdial_dict.get('Formatting Error'), '--error', transdial_dict.get('Please enter information in the correct format.')]
            karamba.executeInteractive(widget, dialcommand) 
        elif (int(match.group('red')) > 255) or (int(match.group('green')) > 255) or (int(match.group('blue')) > 255):
            dialcommand = ['kdialog', '--title',  transdial_dict.get('r,g,b Value Error'), '--error', transdial_dict.get('r, g, b values may not be greater than 255.')]
            karamba.executeInteractive(widget, dialcommand)
        else:
            reddrop = int(match.group('red'))
            greendrop = int(match.group('green'))
            bluedrop = int(match.group('blue'))
            karamba.writeConfigEntry(widget, "dropcolor", 'r=' + str(match.group('red')) + ' g=' + str(match.group('green')) + ' b=' + str(match.group('blue')))
            configchange = 0
            widgetUpdated(widget)

                   
    elif pid == translationpid:
        print "output of translationpid:" + output
        language = os.listdir(os.getcwd() + '/translations')[int(output)]
        print "language changed to:" + language
        karamba.writeConfigEntry(widget, "language", language)
        configchange = 1
        widgetUpdated(widget)

    elif pid == iconpid:
        print "output of iconpid:" + output
        if output:
            print "got something"
        iconset = output.replace('\n','')
        if iconset == "flat":
            flatflag = 1
            flatstring = 'flat'
        else:
            flatflag = 0
            flatstring = ''
        iconsetpath = 'icons/' + iconset + '/'
        karamba.writeConfigEntry(widget, "iconset", iconset)
        configchange = 0
        widgetUpdated(widget)

    elif pid == delaypid:
        delay = int(output.replace('\n',''))
        print "delay is now: " + str(delaylist[delay])
        configchange = 0
        widgetUpdated(widget)
        
    elif pid == bkgdpid:
        mainback = output.replace('\n','')
        karamba.writeConfigEntry(widget, "bkgd", mainback)
        karamba.deleteImage(widget, background)
        karamba.deleteImage(widget, windpic_bg)
        background = karamba.createBackgroundImage(widget, 15, 15, 'background/' + mainback)
        karamba.redrawWidgetBackground(widget)
        if flatflag == 1:
            windpic_bg = karamba.createBackgroundImage(widget, 180, 62, "wind_icons/flat/wind_bg.png")
        else:
            windpic_bg = karamba.createBackgroundImage(widget, 192, 70, "wind_icons/liquid/wind_bg.png")
        if mainback == 'bg9.png':
            altback = 1
        elif mainback == 'bg17.png':
            altback = 2
        else:
            altback = 0
        karamba.redrawWidgetBackground(widget)
        configchange = 0
        widgetUpdated(widget)

    elif pid == locpid:
        zipcode = output.replace('\n','')
        if (zipcode != ""):
            if len(zipcode) > 4 :
                url = url_base_addr + zipcode + url_suffix
                use_wcom = 1
                wcomcode = zipcode
                satpicurl = "http://www.w3.weather.com/outlook/travel/map/" + zipcode
            else:
                url= url_bbc_base_addr + zipcode + url_bbc_add_addr
                use_wcom = 0
            karamba.writeConfigEntry(widget, "url", url)
            widgetUpdated(widget)
        configchange = 1
        werethreading = 1
        widgetUpdated(widget)

    elif pid == wcompid:
        city = output.replace('\n','')
        city1 = urllib.quote_plus(city)
        wcomurl =  "http://xoap.weather.com/search/search?where=" + city1
        #wcomurl = quote_plus(wcomurl)
        searchsite = 0
        searchCodes(widget, wcomurl)

    elif pid == bbcpid:
        city = output.replace('\n','')
        city1 = urllib.quote_plus(city)
        bbcurl =  'http://www.bbc.co.uk/cgi-bin/weather/world_location/location.cgi?wlocation=' + city1 + '&imageField.x=0&imageField.y=0'
        searchsite = 1
        searchCodes(widget, bbcurl)

    elif pid == wcomcodespid:
        zipcode = output.replace('\n','')
        print zipcode
        url = url_base_addr + zipcode + url_suffix
        karamba.writeConfigEntry(widget, "url", url)
        use_wcom = 1
        wcomcode = zipcode
        satpicurl = "http://www.w3.weather.com/outlook/travel/map/" + zipcode
        configchange = 1
        werethreading = 1
        widgetUpdated(widget)

    elif pid == bbccodespid:
        zipcode = output.replace('\n','')
        url= url_bbc_base_addr + zipcode + url_bbc_add_addr
        karamba.writeConfigEntry(widget, "url", url)
        use_wcom = 0
        configchange = 1
        werethreading = 1
        widgetUpdated(widget)

    elif pid == webcamurlpid:
        zipcode = output.replace('\n','')
        if len(zipcode) != 0:
            from mimetypes import guess_type
            try:
                test = urllib2.urlopen(zipcode).read()
                save = open(installed + '/test.jpg', 'w')
                print >> save, test
                save.close()
                imagetest = guess_type(installed + '/test.jpg')
                imagetester = imagetest[0].find('image')
                if imagetester == 0:
                    errorflag = 0
                else:
                    errorflag = 1
                if errorflag == 0:
                    #url_webcam = zipcode
                    nowebcams = len(webcamlabels)
                    if (nowebcams == None):
                        nowebcams = 0
                    karamba.writeConfigEntry(widget, "webcamurl_" + str(webcamsfree[0]), zipcode)
                    webcamurls.append(zipcode)
                    #configchange = 1
                    addwebcamlabelcommand = ["kdialog", "--title", transdial_dict.get('Add Webcam Label'), "--inputbox", transdial_dict.get('Enter a label for this webcam:')]
                    webcamlabelpid = karamba.executeInteractive(widget, addwebcamlabelcommand)
                else:
                    #print "gone haywire
                    dialcommand = ['kdialog', '--title',  transdial_dict.get('URL Does Not Exist'), '--error', transdial_dict.get('URL does not point to an image')]
                    karamba.executeInteractive(widget, dialcommand)

            except:
                #print "gone haywire except"
                dialcommand = ['kdialog', '--title',  transdial_dict.get('URL Does Not Exist'), '--error', transdial_dict.get('URL does not point to an image')]
                karamba.executeInteractive(widget, dialcommand)

    elif pid == webcamlabelpid:
        labely = output.replace('\n','')
        karamba.writeConfigEntry(widget, "webcamlabel_" + str(webcamsfree[0]), labely)
        webcamlabels.append(labely)
        nowebcams = len(webcamlabels)
        webcamsfree.pop(0)
        #loadingtext = karamba.createText(widget, 120, 90, 200, 18, "Loading...")
        #prettyText(widget, 10, "verdana", shadow, loadingtext)
        #karamba.redrawWidget(widget)
        #getWebcamPic(widget)
        #karamba.deleteText(widget, loadingtext)
        #karamba.redrawWidget(widget)
        configchange = 1
        werethreading = 1
        widgetUpdated(widget)

    elif pid == remwebcampid:
        index = output.replace('\n','')
        index = int(index)
        webcamurls.pop(index)
        webcamlabels.pop(index)
        nowebcams = len(webcamlabels)
        karamba.writeConfigEntry(widget, "webcamurl_" + str(index), '')
        karamba.writeConfigEntry(widget, "webcamlabel_" + str(index), '')
        webcamsfree.append(index)
        #loadingtext = karamba.createText(widget, 120, 90, 200, 18, "Loading...")
        #prettyText(widget, 10, "verdana", shadow, loadingtext)
        #karamba.redrawWidget(widget)
        #getWebcamPic(widget)
        #karamba.deleteText(widget, loadingtext)
        #karamba.redrawWidget(widget)
        configchange = 1
        werethreading = 1
        widgetUpdated(widget)
